package org.eclipse.trace4cps.tl.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.trace4cps.tl.services.EtlGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 */
@SuppressWarnings("all")
public class InternalEtlParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT_T", "RULE_DOUBLE_T", "RULE_STRING", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'signal'", "':'", "'def'", "'('", "')'", "'check'", "'forall'", "'...'", "'throughput'", "'of'", "'per'", "'latency'", "'in'", "'wip'", "'resource-amount'", "'resource-clients'", "'over'", "'+'", "'not'", "'if'", "'then'", "'globally'", "'during'", "'finally'", "'within'", "'until'", "'we'", "'have'", "'that'", "'by'", "'and'", "'d'", "'/'", "'dt'", "'start'", "'end'", "'{'", "','", "'}'", "'='", "'Infty'", "']'", "'['", "'s'", "'ns'", "'us'", "'ms'", "'min'", "'hr'", "'or'", "'<='", "'=='", "'>='"
    };
    public static final int T__50=50;
    public static final int RULE_INT_T=5;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__59=59;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__55=55;
    public static final int T__56=56;
    public static final int T__13=13;
    public static final int T__57=57;
    public static final int T__14=14;
    public static final int T__58=58;
    public static final int T__51=51;
    public static final int T__52=52;
    public static final int T__53=53;
    public static final int T__54=54;
    public static final int T__60=60;
    public static final int T__61=61;
    public static final int RULE_ID=4;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int RULE_INT=8;
    public static final int T__29=29;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=9;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__62=62;
    public static final int T__63=63;
    public static final int T__20=20;
    public static final int T__64=64;
    public static final int T__21=21;
    public static final int T__65=65;
    public static final int RULE_STRING=7;
    public static final int RULE_SL_COMMENT=10;
    public static final int T__37=37;
    public static final int T__38=38;
    public static final int T__39=39;
    public static final int T__33=33;
    public static final int T__34=34;
    public static final int T__35=35;
    public static final int T__36=36;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int RULE_WS=11;
    public static final int RULE_ANY_OTHER=12;
    public static final int T__48=48;
    public static final int T__49=49;
    public static final int T__44=44;
    public static final int T__45=45;
    public static final int T__46=46;
    public static final int T__47=47;
    public static final int T__40=40;
    public static final int T__41=41;
    public static final int T__42=42;
    public static final int RULE_DOUBLE_T=6;
    public static final int T__43=43;

    // delegates
    // delegators


        public InternalEtlParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalEtlParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalEtlParser.tokenNames; }
    public String getGrammarFileName() { return "InternalEtl.g"; }



     	private EtlGrammarAccess grammarAccess;

        public InternalEtlParser(TokenStream input, EtlGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "EtlModel";
       	}

       	@Override
       	protected EtlGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleEtlModel"
    // InternalEtl.g:75:1: entryRuleEtlModel returns [EObject current=null] : iv_ruleEtlModel= ruleEtlModel EOF ;
    public final EObject entryRuleEtlModel() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEtlModel = null;


        try {
            // InternalEtl.g:75:49: (iv_ruleEtlModel= ruleEtlModel EOF )
            // InternalEtl.g:76:2: iv_ruleEtlModel= ruleEtlModel EOF
            {
             newCompositeNode(grammarAccess.getEtlModelRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleEtlModel=ruleEtlModel();

            state._fsp--;

             current =iv_ruleEtlModel; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEtlModel"


    // $ANTLR start "ruleEtlModel"
    // InternalEtl.g:82:1: ruleEtlModel returns [EObject current=null] : ( (lv_elements_0_0= ruleTopLevelModelElement ) )* ;
    public final EObject ruleEtlModel() throws RecognitionException {
        EObject current = null;

        EObject lv_elements_0_0 = null;



        	enterRule();

        try {
            // InternalEtl.g:88:2: ( ( (lv_elements_0_0= ruleTopLevelModelElement ) )* )
            // InternalEtl.g:89:2: ( (lv_elements_0_0= ruleTopLevelModelElement ) )*
            {
            // InternalEtl.g:89:2: ( (lv_elements_0_0= ruleTopLevelModelElement ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==13||LA1_0==15||LA1_0==18) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalEtl.g:90:3: (lv_elements_0_0= ruleTopLevelModelElement )
            	    {
            	    // InternalEtl.g:90:3: (lv_elements_0_0= ruleTopLevelModelElement )
            	    // InternalEtl.g:91:4: lv_elements_0_0= ruleTopLevelModelElement
            	    {

            	    				newCompositeNode(grammarAccess.getEtlModelAccess().getElementsTopLevelModelElementParserRuleCall_0());
            	    			
            	    pushFollow(FOLLOW_3);
            	    lv_elements_0_0=ruleTopLevelModelElement();

            	    state._fsp--;


            	    				if (current==null) {
            	    					current = createModelElementForParent(grammarAccess.getEtlModelRule());
            	    				}
            	    				add(
            	    					current,
            	    					"elements",
            	    					lv_elements_0_0,
            	    					"org.eclipse.trace4cps.tl.Etl.TopLevelModelElement");
            	    				afterParserOrEnumRuleCall();
            	    			

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEtlModel"


    // $ANTLR start "entryRuleTopLevelModelElement"
    // InternalEtl.g:111:1: entryRuleTopLevelModelElement returns [EObject current=null] : iv_ruleTopLevelModelElement= ruleTopLevelModelElement EOF ;
    public final EObject entryRuleTopLevelModelElement() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTopLevelModelElement = null;


        try {
            // InternalEtl.g:111:61: (iv_ruleTopLevelModelElement= ruleTopLevelModelElement EOF )
            // InternalEtl.g:112:2: iv_ruleTopLevelModelElement= ruleTopLevelModelElement EOF
            {
             newCompositeNode(grammarAccess.getTopLevelModelElementRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleTopLevelModelElement=ruleTopLevelModelElement();

            state._fsp--;

             current =iv_ruleTopLevelModelElement; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTopLevelModelElement"


    // $ANTLR start "ruleTopLevelModelElement"
    // InternalEtl.g:118:1: ruleTopLevelModelElement returns [EObject current=null] : ( ( () otherlv_1= 'signal' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ':' ( (lv_signal_4_0= ruleSignal ) ) ) | ( () otherlv_6= 'def' ( (lv_name_7_0= RULE_ID ) ) (otherlv_8= '(' ( (lv_param_9_0= RULE_ID ) ) otherlv_10= ')' )? otherlv_11= ':' ( (lv_formula_12_0= ruleFormula ) ) ) | ( () otherlv_14= 'check' ( (lv_name_15_0= RULE_ID ) ) otherlv_16= ':' (otherlv_17= 'forall' otherlv_18= '(' ( (lv_var_19_0= RULE_ID ) ) otherlv_20= ':' ( (lv_lb_21_0= RULE_INT_T ) ) otherlv_22= '...' ( (lv_ub_23_0= RULE_INT_T ) ) otherlv_24= ')' )? ( (lv_formula_25_0= ruleFormula ) ) ) ) ;
    public final EObject ruleTopLevelModelElement() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token lv_name_2_0=null;
        Token otherlv_3=null;
        Token otherlv_6=null;
        Token lv_name_7_0=null;
        Token otherlv_8=null;
        Token lv_param_9_0=null;
        Token otherlv_10=null;
        Token otherlv_11=null;
        Token otherlv_14=null;
        Token lv_name_15_0=null;
        Token otherlv_16=null;
        Token otherlv_17=null;
        Token otherlv_18=null;
        Token lv_var_19_0=null;
        Token otherlv_20=null;
        Token lv_lb_21_0=null;
        Token otherlv_22=null;
        Token lv_ub_23_0=null;
        Token otherlv_24=null;
        EObject lv_signal_4_0 = null;

        EObject lv_formula_12_0 = null;

        EObject lv_formula_25_0 = null;



        	enterRule();

        try {
            // InternalEtl.g:124:2: ( ( ( () otherlv_1= 'signal' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ':' ( (lv_signal_4_0= ruleSignal ) ) ) | ( () otherlv_6= 'def' ( (lv_name_7_0= RULE_ID ) ) (otherlv_8= '(' ( (lv_param_9_0= RULE_ID ) ) otherlv_10= ')' )? otherlv_11= ':' ( (lv_formula_12_0= ruleFormula ) ) ) | ( () otherlv_14= 'check' ( (lv_name_15_0= RULE_ID ) ) otherlv_16= ':' (otherlv_17= 'forall' otherlv_18= '(' ( (lv_var_19_0= RULE_ID ) ) otherlv_20= ':' ( (lv_lb_21_0= RULE_INT_T ) ) otherlv_22= '...' ( (lv_ub_23_0= RULE_INT_T ) ) otherlv_24= ')' )? ( (lv_formula_25_0= ruleFormula ) ) ) ) )
            // InternalEtl.g:125:2: ( ( () otherlv_1= 'signal' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ':' ( (lv_signal_4_0= ruleSignal ) ) ) | ( () otherlv_6= 'def' ( (lv_name_7_0= RULE_ID ) ) (otherlv_8= '(' ( (lv_param_9_0= RULE_ID ) ) otherlv_10= ')' )? otherlv_11= ':' ( (lv_formula_12_0= ruleFormula ) ) ) | ( () otherlv_14= 'check' ( (lv_name_15_0= RULE_ID ) ) otherlv_16= ':' (otherlv_17= 'forall' otherlv_18= '(' ( (lv_var_19_0= RULE_ID ) ) otherlv_20= ':' ( (lv_lb_21_0= RULE_INT_T ) ) otherlv_22= '...' ( (lv_ub_23_0= RULE_INT_T ) ) otherlv_24= ')' )? ( (lv_formula_25_0= ruleFormula ) ) ) )
            {
            // InternalEtl.g:125:2: ( ( () otherlv_1= 'signal' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ':' ( (lv_signal_4_0= ruleSignal ) ) ) | ( () otherlv_6= 'def' ( (lv_name_7_0= RULE_ID ) ) (otherlv_8= '(' ( (lv_param_9_0= RULE_ID ) ) otherlv_10= ')' )? otherlv_11= ':' ( (lv_formula_12_0= ruleFormula ) ) ) | ( () otherlv_14= 'check' ( (lv_name_15_0= RULE_ID ) ) otherlv_16= ':' (otherlv_17= 'forall' otherlv_18= '(' ( (lv_var_19_0= RULE_ID ) ) otherlv_20= ':' ( (lv_lb_21_0= RULE_INT_T ) ) otherlv_22= '...' ( (lv_ub_23_0= RULE_INT_T ) ) otherlv_24= ')' )? ( (lv_formula_25_0= ruleFormula ) ) ) )
            int alt4=3;
            switch ( input.LA(1) ) {
            case 13:
                {
                alt4=1;
                }
                break;
            case 15:
                {
                alt4=2;
                }
                break;
            case 18:
                {
                alt4=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }

            switch (alt4) {
                case 1 :
                    // InternalEtl.g:126:3: ( () otherlv_1= 'signal' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ':' ( (lv_signal_4_0= ruleSignal ) ) )
                    {
                    // InternalEtl.g:126:3: ( () otherlv_1= 'signal' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ':' ( (lv_signal_4_0= ruleSignal ) ) )
                    // InternalEtl.g:127:4: () otherlv_1= 'signal' ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ':' ( (lv_signal_4_0= ruleSignal ) )
                    {
                    // InternalEtl.g:127:4: ()
                    // InternalEtl.g:128:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getTopLevelModelElementAccess().getSignalDefAction_0_0(),
                    						current);
                    				

                    }

                    otherlv_1=(Token)match(input,13,FOLLOW_4); 

                    				newLeafNode(otherlv_1, grammarAccess.getTopLevelModelElementAccess().getSignalKeyword_0_1());
                    			
                    // InternalEtl.g:138:4: ( (lv_name_2_0= RULE_ID ) )
                    // InternalEtl.g:139:5: (lv_name_2_0= RULE_ID )
                    {
                    // InternalEtl.g:139:5: (lv_name_2_0= RULE_ID )
                    // InternalEtl.g:140:6: lv_name_2_0= RULE_ID
                    {
                    lv_name_2_0=(Token)match(input,RULE_ID,FOLLOW_5); 

                    						newLeafNode(lv_name_2_0, grammarAccess.getTopLevelModelElementAccess().getNameIDTerminalRuleCall_0_2_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getTopLevelModelElementRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"name",
                    							lv_name_2_0,
                    							"org.eclipse.xtext.common.Terminals.ID");
                    					

                    }


                    }

                    otherlv_3=(Token)match(input,14,FOLLOW_6); 

                    				newLeafNode(otherlv_3, grammarAccess.getTopLevelModelElementAccess().getColonKeyword_0_3());
                    			
                    // InternalEtl.g:160:4: ( (lv_signal_4_0= ruleSignal ) )
                    // InternalEtl.g:161:5: (lv_signal_4_0= ruleSignal )
                    {
                    // InternalEtl.g:161:5: (lv_signal_4_0= ruleSignal )
                    // InternalEtl.g:162:6: lv_signal_4_0= ruleSignal
                    {

                    						newCompositeNode(grammarAccess.getTopLevelModelElementAccess().getSignalSignalParserRuleCall_0_4_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_signal_4_0=ruleSignal();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getTopLevelModelElementRule());
                    						}
                    						set(
                    							current,
                    							"signal",
                    							lv_signal_4_0,
                    							"org.eclipse.trace4cps.tl.Etl.Signal");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:181:3: ( () otherlv_6= 'def' ( (lv_name_7_0= RULE_ID ) ) (otherlv_8= '(' ( (lv_param_9_0= RULE_ID ) ) otherlv_10= ')' )? otherlv_11= ':' ( (lv_formula_12_0= ruleFormula ) ) )
                    {
                    // InternalEtl.g:181:3: ( () otherlv_6= 'def' ( (lv_name_7_0= RULE_ID ) ) (otherlv_8= '(' ( (lv_param_9_0= RULE_ID ) ) otherlv_10= ')' )? otherlv_11= ':' ( (lv_formula_12_0= ruleFormula ) ) )
                    // InternalEtl.g:182:4: () otherlv_6= 'def' ( (lv_name_7_0= RULE_ID ) ) (otherlv_8= '(' ( (lv_param_9_0= RULE_ID ) ) otherlv_10= ')' )? otherlv_11= ':' ( (lv_formula_12_0= ruleFormula ) )
                    {
                    // InternalEtl.g:182:4: ()
                    // InternalEtl.g:183:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getTopLevelModelElementAccess().getDefAction_1_0(),
                    						current);
                    				

                    }

                    otherlv_6=(Token)match(input,15,FOLLOW_4); 

                    				newLeafNode(otherlv_6, grammarAccess.getTopLevelModelElementAccess().getDefKeyword_1_1());
                    			
                    // InternalEtl.g:193:4: ( (lv_name_7_0= RULE_ID ) )
                    // InternalEtl.g:194:5: (lv_name_7_0= RULE_ID )
                    {
                    // InternalEtl.g:194:5: (lv_name_7_0= RULE_ID )
                    // InternalEtl.g:195:6: lv_name_7_0= RULE_ID
                    {
                    lv_name_7_0=(Token)match(input,RULE_ID,FOLLOW_7); 

                    						newLeafNode(lv_name_7_0, grammarAccess.getTopLevelModelElementAccess().getNameIDTerminalRuleCall_1_2_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getTopLevelModelElementRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"name",
                    							lv_name_7_0,
                    							"org.eclipse.xtext.common.Terminals.ID");
                    					

                    }


                    }

                    // InternalEtl.g:211:4: (otherlv_8= '(' ( (lv_param_9_0= RULE_ID ) ) otherlv_10= ')' )?
                    int alt2=2;
                    int LA2_0 = input.LA(1);

                    if ( (LA2_0==16) ) {
                        alt2=1;
                    }
                    switch (alt2) {
                        case 1 :
                            // InternalEtl.g:212:5: otherlv_8= '(' ( (lv_param_9_0= RULE_ID ) ) otherlv_10= ')'
                            {
                            otherlv_8=(Token)match(input,16,FOLLOW_4); 

                            					newLeafNode(otherlv_8, grammarAccess.getTopLevelModelElementAccess().getLeftParenthesisKeyword_1_3_0());
                            				
                            // InternalEtl.g:216:5: ( (lv_param_9_0= RULE_ID ) )
                            // InternalEtl.g:217:6: (lv_param_9_0= RULE_ID )
                            {
                            // InternalEtl.g:217:6: (lv_param_9_0= RULE_ID )
                            // InternalEtl.g:218:7: lv_param_9_0= RULE_ID
                            {
                            lv_param_9_0=(Token)match(input,RULE_ID,FOLLOW_8); 

                            							newLeafNode(lv_param_9_0, grammarAccess.getTopLevelModelElementAccess().getParamIDTerminalRuleCall_1_3_1_0());
                            						

                            							if (current==null) {
                            								current = createModelElement(grammarAccess.getTopLevelModelElementRule());
                            							}
                            							setWithLastConsumed(
                            								current,
                            								"param",
                            								lv_param_9_0,
                            								"org.eclipse.xtext.common.Terminals.ID");
                            						

                            }


                            }

                            otherlv_10=(Token)match(input,17,FOLLOW_5); 

                            					newLeafNode(otherlv_10, grammarAccess.getTopLevelModelElementAccess().getRightParenthesisKeyword_1_3_2());
                            				

                            }
                            break;

                    }

                    otherlv_11=(Token)match(input,14,FOLLOW_9); 

                    				newLeafNode(otherlv_11, grammarAccess.getTopLevelModelElementAccess().getColonKeyword_1_4());
                    			
                    // InternalEtl.g:243:4: ( (lv_formula_12_0= ruleFormula ) )
                    // InternalEtl.g:244:5: (lv_formula_12_0= ruleFormula )
                    {
                    // InternalEtl.g:244:5: (lv_formula_12_0= ruleFormula )
                    // InternalEtl.g:245:6: lv_formula_12_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getTopLevelModelElementAccess().getFormulaFormulaParserRuleCall_1_5_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_formula_12_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getTopLevelModelElementRule());
                    						}
                    						set(
                    							current,
                    							"formula",
                    							lv_formula_12_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 3 :
                    // InternalEtl.g:264:3: ( () otherlv_14= 'check' ( (lv_name_15_0= RULE_ID ) ) otherlv_16= ':' (otherlv_17= 'forall' otherlv_18= '(' ( (lv_var_19_0= RULE_ID ) ) otherlv_20= ':' ( (lv_lb_21_0= RULE_INT_T ) ) otherlv_22= '...' ( (lv_ub_23_0= RULE_INT_T ) ) otherlv_24= ')' )? ( (lv_formula_25_0= ruleFormula ) ) )
                    {
                    // InternalEtl.g:264:3: ( () otherlv_14= 'check' ( (lv_name_15_0= RULE_ID ) ) otherlv_16= ':' (otherlv_17= 'forall' otherlv_18= '(' ( (lv_var_19_0= RULE_ID ) ) otherlv_20= ':' ( (lv_lb_21_0= RULE_INT_T ) ) otherlv_22= '...' ( (lv_ub_23_0= RULE_INT_T ) ) otherlv_24= ')' )? ( (lv_formula_25_0= ruleFormula ) ) )
                    // InternalEtl.g:265:4: () otherlv_14= 'check' ( (lv_name_15_0= RULE_ID ) ) otherlv_16= ':' (otherlv_17= 'forall' otherlv_18= '(' ( (lv_var_19_0= RULE_ID ) ) otherlv_20= ':' ( (lv_lb_21_0= RULE_INT_T ) ) otherlv_22= '...' ( (lv_ub_23_0= RULE_INT_T ) ) otherlv_24= ')' )? ( (lv_formula_25_0= ruleFormula ) )
                    {
                    // InternalEtl.g:265:4: ()
                    // InternalEtl.g:266:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getTopLevelModelElementAccess().getCheckAction_2_0(),
                    						current);
                    				

                    }

                    otherlv_14=(Token)match(input,18,FOLLOW_4); 

                    				newLeafNode(otherlv_14, grammarAccess.getTopLevelModelElementAccess().getCheckKeyword_2_1());
                    			
                    // InternalEtl.g:276:4: ( (lv_name_15_0= RULE_ID ) )
                    // InternalEtl.g:277:5: (lv_name_15_0= RULE_ID )
                    {
                    // InternalEtl.g:277:5: (lv_name_15_0= RULE_ID )
                    // InternalEtl.g:278:6: lv_name_15_0= RULE_ID
                    {
                    lv_name_15_0=(Token)match(input,RULE_ID,FOLLOW_5); 

                    						newLeafNode(lv_name_15_0, grammarAccess.getTopLevelModelElementAccess().getNameIDTerminalRuleCall_2_2_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getTopLevelModelElementRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"name",
                    							lv_name_15_0,
                    							"org.eclipse.xtext.common.Terminals.ID");
                    					

                    }


                    }

                    otherlv_16=(Token)match(input,14,FOLLOW_10); 

                    				newLeafNode(otherlv_16, grammarAccess.getTopLevelModelElementAccess().getColonKeyword_2_3());
                    			
                    // InternalEtl.g:298:4: (otherlv_17= 'forall' otherlv_18= '(' ( (lv_var_19_0= RULE_ID ) ) otherlv_20= ':' ( (lv_lb_21_0= RULE_INT_T ) ) otherlv_22= '...' ( (lv_ub_23_0= RULE_INT_T ) ) otherlv_24= ')' )?
                    int alt3=2;
                    int LA3_0 = input.LA(1);

                    if ( (LA3_0==19) ) {
                        alt3=1;
                    }
                    switch (alt3) {
                        case 1 :
                            // InternalEtl.g:299:5: otherlv_17= 'forall' otherlv_18= '(' ( (lv_var_19_0= RULE_ID ) ) otherlv_20= ':' ( (lv_lb_21_0= RULE_INT_T ) ) otherlv_22= '...' ( (lv_ub_23_0= RULE_INT_T ) ) otherlv_24= ')'
                            {
                            otherlv_17=(Token)match(input,19,FOLLOW_11); 

                            					newLeafNode(otherlv_17, grammarAccess.getTopLevelModelElementAccess().getForallKeyword_2_4_0());
                            				
                            otherlv_18=(Token)match(input,16,FOLLOW_4); 

                            					newLeafNode(otherlv_18, grammarAccess.getTopLevelModelElementAccess().getLeftParenthesisKeyword_2_4_1());
                            				
                            // InternalEtl.g:307:5: ( (lv_var_19_0= RULE_ID ) )
                            // InternalEtl.g:308:6: (lv_var_19_0= RULE_ID )
                            {
                            // InternalEtl.g:308:6: (lv_var_19_0= RULE_ID )
                            // InternalEtl.g:309:7: lv_var_19_0= RULE_ID
                            {
                            lv_var_19_0=(Token)match(input,RULE_ID,FOLLOW_5); 

                            							newLeafNode(lv_var_19_0, grammarAccess.getTopLevelModelElementAccess().getVarIDTerminalRuleCall_2_4_2_0());
                            						

                            							if (current==null) {
                            								current = createModelElement(grammarAccess.getTopLevelModelElementRule());
                            							}
                            							setWithLastConsumed(
                            								current,
                            								"var",
                            								lv_var_19_0,
                            								"org.eclipse.xtext.common.Terminals.ID");
                            						

                            }


                            }

                            otherlv_20=(Token)match(input,14,FOLLOW_12); 

                            					newLeafNode(otherlv_20, grammarAccess.getTopLevelModelElementAccess().getColonKeyword_2_4_3());
                            				
                            // InternalEtl.g:329:5: ( (lv_lb_21_0= RULE_INT_T ) )
                            // InternalEtl.g:330:6: (lv_lb_21_0= RULE_INT_T )
                            {
                            // InternalEtl.g:330:6: (lv_lb_21_0= RULE_INT_T )
                            // InternalEtl.g:331:7: lv_lb_21_0= RULE_INT_T
                            {
                            lv_lb_21_0=(Token)match(input,RULE_INT_T,FOLLOW_13); 

                            							newLeafNode(lv_lb_21_0, grammarAccess.getTopLevelModelElementAccess().getLbINT_TTerminalRuleCall_2_4_4_0());
                            						

                            							if (current==null) {
                            								current = createModelElement(grammarAccess.getTopLevelModelElementRule());
                            							}
                            							setWithLastConsumed(
                            								current,
                            								"lb",
                            								lv_lb_21_0,
                            								"org.eclipse.trace4cps.tl.Etl.INT_T");
                            						

                            }


                            }

                            otherlv_22=(Token)match(input,20,FOLLOW_12); 

                            					newLeafNode(otherlv_22, grammarAccess.getTopLevelModelElementAccess().getFullStopFullStopFullStopKeyword_2_4_5());
                            				
                            // InternalEtl.g:351:5: ( (lv_ub_23_0= RULE_INT_T ) )
                            // InternalEtl.g:352:6: (lv_ub_23_0= RULE_INT_T )
                            {
                            // InternalEtl.g:352:6: (lv_ub_23_0= RULE_INT_T )
                            // InternalEtl.g:353:7: lv_ub_23_0= RULE_INT_T
                            {
                            lv_ub_23_0=(Token)match(input,RULE_INT_T,FOLLOW_8); 

                            							newLeafNode(lv_ub_23_0, grammarAccess.getTopLevelModelElementAccess().getUbINT_TTerminalRuleCall_2_4_6_0());
                            						

                            							if (current==null) {
                            								current = createModelElement(grammarAccess.getTopLevelModelElementRule());
                            							}
                            							setWithLastConsumed(
                            								current,
                            								"ub",
                            								lv_ub_23_0,
                            								"org.eclipse.trace4cps.tl.Etl.INT_T");
                            						

                            }


                            }

                            otherlv_24=(Token)match(input,17,FOLLOW_9); 

                            					newLeafNode(otherlv_24, grammarAccess.getTopLevelModelElementAccess().getRightParenthesisKeyword_2_4_7());
                            				

                            }
                            break;

                    }

                    // InternalEtl.g:374:4: ( (lv_formula_25_0= ruleFormula ) )
                    // InternalEtl.g:375:5: (lv_formula_25_0= ruleFormula )
                    {
                    // InternalEtl.g:375:5: (lv_formula_25_0= ruleFormula )
                    // InternalEtl.g:376:6: lv_formula_25_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getTopLevelModelElementAccess().getFormulaFormulaParserRuleCall_2_5_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_formula_25_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getTopLevelModelElementRule());
                    						}
                    						set(
                    							current,
                    							"formula",
                    							lv_formula_25_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTopLevelModelElement"


    // $ANTLR start "entryRuleSignal"
    // InternalEtl.g:398:1: entryRuleSignal returns [EObject current=null] : iv_ruleSignal= ruleSignal EOF ;
    public final EObject entryRuleSignal() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSignal = null;


        try {
            // InternalEtl.g:398:47: (iv_ruleSignal= ruleSignal EOF )
            // InternalEtl.g:399:2: iv_ruleSignal= ruleSignal EOF
            {
             newCompositeNode(grammarAccess.getSignalRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleSignal=ruleSignal();

            state._fsp--;

             current =iv_ruleSignal; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSignal"


    // $ANTLR start "ruleSignal"
    // InternalEtl.g:405:1: ruleSignal returns [EObject current=null] : ( ( () ( (lv_filter_1_0= ruleAttributeFilter ) ) ) | ( () otherlv_3= 'throughput' otherlv_4= 'of' ( ( (lv_idAtt_5_0= RULE_ID ) ) | ( (lv_ap_6_0= ruleMtlAp ) ) ) (otherlv_7= 'per' ( (lv_scale_8_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_9_0= ruleConvSpec ) )? ) | ( () otherlv_11= 'latency' otherlv_12= 'of' ( (lv_idAtt_13_0= RULE_ID ) ) (otherlv_14= 'in' ( (lv_scale_15_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_16_0= ruleConvSpec ) )? ) | ( () otherlv_18= 'wip' otherlv_19= 'of' ( (lv_idAtt_20_0= RULE_ID ) ) ( (lv_convSpec_21_0= ruleConvSpec ) )? ) | ( () otherlv_23= 'resource-amount' ( (lv_filter_24_0= ruleAttributeFilter ) ) ( (lv_convSpec_25_0= ruleConvSpec ) )? ) | ( () otherlv_27= 'resource-clients' ( (lv_filter_28_0= ruleAttributeFilter ) ) ( (lv_convSpec_29_0= ruleConvSpec ) )? ) ) ;
    public final EObject ruleSignal() throws RecognitionException {
        EObject current = null;

        Token otherlv_3=null;
        Token otherlv_4=null;
        Token lv_idAtt_5_0=null;
        Token otherlv_7=null;
        Token otherlv_11=null;
        Token otherlv_12=null;
        Token lv_idAtt_13_0=null;
        Token otherlv_14=null;
        Token otherlv_18=null;
        Token otherlv_19=null;
        Token lv_idAtt_20_0=null;
        Token otherlv_23=null;
        Token otherlv_27=null;
        EObject lv_filter_1_0 = null;

        EObject lv_ap_6_0 = null;

        Enumerator lv_scale_8_0 = null;

        EObject lv_convSpec_9_0 = null;

        Enumerator lv_scale_15_0 = null;

        EObject lv_convSpec_16_0 = null;

        EObject lv_convSpec_21_0 = null;

        EObject lv_filter_24_0 = null;

        EObject lv_convSpec_25_0 = null;

        EObject lv_filter_28_0 = null;

        EObject lv_convSpec_29_0 = null;



        	enterRule();

        try {
            // InternalEtl.g:411:2: ( ( ( () ( (lv_filter_1_0= ruleAttributeFilter ) ) ) | ( () otherlv_3= 'throughput' otherlv_4= 'of' ( ( (lv_idAtt_5_0= RULE_ID ) ) | ( (lv_ap_6_0= ruleMtlAp ) ) ) (otherlv_7= 'per' ( (lv_scale_8_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_9_0= ruleConvSpec ) )? ) | ( () otherlv_11= 'latency' otherlv_12= 'of' ( (lv_idAtt_13_0= RULE_ID ) ) (otherlv_14= 'in' ( (lv_scale_15_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_16_0= ruleConvSpec ) )? ) | ( () otherlv_18= 'wip' otherlv_19= 'of' ( (lv_idAtt_20_0= RULE_ID ) ) ( (lv_convSpec_21_0= ruleConvSpec ) )? ) | ( () otherlv_23= 'resource-amount' ( (lv_filter_24_0= ruleAttributeFilter ) ) ( (lv_convSpec_25_0= ruleConvSpec ) )? ) | ( () otherlv_27= 'resource-clients' ( (lv_filter_28_0= ruleAttributeFilter ) ) ( (lv_convSpec_29_0= ruleConvSpec ) )? ) ) )
            // InternalEtl.g:412:2: ( ( () ( (lv_filter_1_0= ruleAttributeFilter ) ) ) | ( () otherlv_3= 'throughput' otherlv_4= 'of' ( ( (lv_idAtt_5_0= RULE_ID ) ) | ( (lv_ap_6_0= ruleMtlAp ) ) ) (otherlv_7= 'per' ( (lv_scale_8_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_9_0= ruleConvSpec ) )? ) | ( () otherlv_11= 'latency' otherlv_12= 'of' ( (lv_idAtt_13_0= RULE_ID ) ) (otherlv_14= 'in' ( (lv_scale_15_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_16_0= ruleConvSpec ) )? ) | ( () otherlv_18= 'wip' otherlv_19= 'of' ( (lv_idAtt_20_0= RULE_ID ) ) ( (lv_convSpec_21_0= ruleConvSpec ) )? ) | ( () otherlv_23= 'resource-amount' ( (lv_filter_24_0= ruleAttributeFilter ) ) ( (lv_convSpec_25_0= ruleConvSpec ) )? ) | ( () otherlv_27= 'resource-clients' ( (lv_filter_28_0= ruleAttributeFilter ) ) ( (lv_convSpec_29_0= ruleConvSpec ) )? ) )
            {
            // InternalEtl.g:412:2: ( ( () ( (lv_filter_1_0= ruleAttributeFilter ) ) ) | ( () otherlv_3= 'throughput' otherlv_4= 'of' ( ( (lv_idAtt_5_0= RULE_ID ) ) | ( (lv_ap_6_0= ruleMtlAp ) ) ) (otherlv_7= 'per' ( (lv_scale_8_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_9_0= ruleConvSpec ) )? ) | ( () otherlv_11= 'latency' otherlv_12= 'of' ( (lv_idAtt_13_0= RULE_ID ) ) (otherlv_14= 'in' ( (lv_scale_15_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_16_0= ruleConvSpec ) )? ) | ( () otherlv_18= 'wip' otherlv_19= 'of' ( (lv_idAtt_20_0= RULE_ID ) ) ( (lv_convSpec_21_0= ruleConvSpec ) )? ) | ( () otherlv_23= 'resource-amount' ( (lv_filter_24_0= ruleAttributeFilter ) ) ( (lv_convSpec_25_0= ruleConvSpec ) )? ) | ( () otherlv_27= 'resource-clients' ( (lv_filter_28_0= ruleAttributeFilter ) ) ( (lv_convSpec_29_0= ruleConvSpec ) )? ) )
            int alt13=6;
            switch ( input.LA(1) ) {
            case 49:
                {
                alt13=1;
                }
                break;
            case 21:
                {
                alt13=2;
                }
                break;
            case 24:
                {
                alt13=3;
                }
                break;
            case 26:
                {
                alt13=4;
                }
                break;
            case 27:
                {
                alt13=5;
                }
                break;
            case 28:
                {
                alt13=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 13, 0, input);

                throw nvae;
            }

            switch (alt13) {
                case 1 :
                    // InternalEtl.g:413:3: ( () ( (lv_filter_1_0= ruleAttributeFilter ) ) )
                    {
                    // InternalEtl.g:413:3: ( () ( (lv_filter_1_0= ruleAttributeFilter ) ) )
                    // InternalEtl.g:414:4: () ( (lv_filter_1_0= ruleAttributeFilter ) )
                    {
                    // InternalEtl.g:414:4: ()
                    // InternalEtl.g:415:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getSignalAccess().getTraceSignalAction_0_0(),
                    						current);
                    				

                    }

                    // InternalEtl.g:421:4: ( (lv_filter_1_0= ruleAttributeFilter ) )
                    // InternalEtl.g:422:5: (lv_filter_1_0= ruleAttributeFilter )
                    {
                    // InternalEtl.g:422:5: (lv_filter_1_0= ruleAttributeFilter )
                    // InternalEtl.g:423:6: lv_filter_1_0= ruleAttributeFilter
                    {

                    						newCompositeNode(grammarAccess.getSignalAccess().getFilterAttributeFilterParserRuleCall_0_1_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_filter_1_0=ruleAttributeFilter();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getSignalRule());
                    						}
                    						set(
                    							current,
                    							"filter",
                    							lv_filter_1_0,
                    							"org.eclipse.trace4cps.tl.Etl.AttributeFilter");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:442:3: ( () otherlv_3= 'throughput' otherlv_4= 'of' ( ( (lv_idAtt_5_0= RULE_ID ) ) | ( (lv_ap_6_0= ruleMtlAp ) ) ) (otherlv_7= 'per' ( (lv_scale_8_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_9_0= ruleConvSpec ) )? )
                    {
                    // InternalEtl.g:442:3: ( () otherlv_3= 'throughput' otherlv_4= 'of' ( ( (lv_idAtt_5_0= RULE_ID ) ) | ( (lv_ap_6_0= ruleMtlAp ) ) ) (otherlv_7= 'per' ( (lv_scale_8_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_9_0= ruleConvSpec ) )? )
                    // InternalEtl.g:443:4: () otherlv_3= 'throughput' otherlv_4= 'of' ( ( (lv_idAtt_5_0= RULE_ID ) ) | ( (lv_ap_6_0= ruleMtlAp ) ) ) (otherlv_7= 'per' ( (lv_scale_8_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_9_0= ruleConvSpec ) )?
                    {
                    // InternalEtl.g:443:4: ()
                    // InternalEtl.g:444:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getSignalAccess().getThroughputSignalAction_1_0(),
                    						current);
                    				

                    }

                    otherlv_3=(Token)match(input,21,FOLLOW_14); 

                    				newLeafNode(otherlv_3, grammarAccess.getSignalAccess().getThroughputKeyword_1_1());
                    			
                    otherlv_4=(Token)match(input,22,FOLLOW_15); 

                    				newLeafNode(otherlv_4, grammarAccess.getSignalAccess().getOfKeyword_1_2());
                    			
                    // InternalEtl.g:458:4: ( ( (lv_idAtt_5_0= RULE_ID ) ) | ( (lv_ap_6_0= ruleMtlAp ) ) )
                    int alt5=2;
                    int LA5_0 = input.LA(1);

                    if ( (LA5_0==RULE_ID) ) {
                        alt5=1;
                    }
                    else if ( ((LA5_0>=47 && LA5_0<=49)) ) {
                        alt5=2;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 5, 0, input);

                        throw nvae;
                    }
                    switch (alt5) {
                        case 1 :
                            // InternalEtl.g:459:5: ( (lv_idAtt_5_0= RULE_ID ) )
                            {
                            // InternalEtl.g:459:5: ( (lv_idAtt_5_0= RULE_ID ) )
                            // InternalEtl.g:460:6: (lv_idAtt_5_0= RULE_ID )
                            {
                            // InternalEtl.g:460:6: (lv_idAtt_5_0= RULE_ID )
                            // InternalEtl.g:461:7: lv_idAtt_5_0= RULE_ID
                            {
                            lv_idAtt_5_0=(Token)match(input,RULE_ID,FOLLOW_16); 

                            							newLeafNode(lv_idAtt_5_0, grammarAccess.getSignalAccess().getIdAttIDTerminalRuleCall_1_3_0_0());
                            						

                            							if (current==null) {
                            								current = createModelElement(grammarAccess.getSignalRule());
                            							}
                            							setWithLastConsumed(
                            								current,
                            								"idAtt",
                            								lv_idAtt_5_0,
                            								"org.eclipse.xtext.common.Terminals.ID");
                            						

                            }


                            }


                            }
                            break;
                        case 2 :
                            // InternalEtl.g:478:5: ( (lv_ap_6_0= ruleMtlAp ) )
                            {
                            // InternalEtl.g:478:5: ( (lv_ap_6_0= ruleMtlAp ) )
                            // InternalEtl.g:479:6: (lv_ap_6_0= ruleMtlAp )
                            {
                            // InternalEtl.g:479:6: (lv_ap_6_0= ruleMtlAp )
                            // InternalEtl.g:480:7: lv_ap_6_0= ruleMtlAp
                            {

                            							newCompositeNode(grammarAccess.getSignalAccess().getApMtlApParserRuleCall_1_3_1_0());
                            						
                            pushFollow(FOLLOW_16);
                            lv_ap_6_0=ruleMtlAp();

                            state._fsp--;


                            							if (current==null) {
                            								current = createModelElementForParent(grammarAccess.getSignalRule());
                            							}
                            							set(
                            								current,
                            								"ap",
                            								lv_ap_6_0,
                            								"org.eclipse.trace4cps.tl.Etl.MtlAp");
                            							afterParserOrEnumRuleCall();
                            						

                            }


                            }


                            }
                            break;

                    }

                    // InternalEtl.g:498:4: (otherlv_7= 'per' ( (lv_scale_8_0= ruleTimeUnitEnum ) ) )?
                    int alt6=2;
                    int LA6_0 = input.LA(1);

                    if ( (LA6_0==23) ) {
                        alt6=1;
                    }
                    switch (alt6) {
                        case 1 :
                            // InternalEtl.g:499:5: otherlv_7= 'per' ( (lv_scale_8_0= ruleTimeUnitEnum ) )
                            {
                            otherlv_7=(Token)match(input,23,FOLLOW_17); 

                            					newLeafNode(otherlv_7, grammarAccess.getSignalAccess().getPerKeyword_1_4_0());
                            				
                            // InternalEtl.g:503:5: ( (lv_scale_8_0= ruleTimeUnitEnum ) )
                            // InternalEtl.g:504:6: (lv_scale_8_0= ruleTimeUnitEnum )
                            {
                            // InternalEtl.g:504:6: (lv_scale_8_0= ruleTimeUnitEnum )
                            // InternalEtl.g:505:7: lv_scale_8_0= ruleTimeUnitEnum
                            {

                            							newCompositeNode(grammarAccess.getSignalAccess().getScaleTimeUnitEnumEnumRuleCall_1_4_1_0());
                            						
                            pushFollow(FOLLOW_18);
                            lv_scale_8_0=ruleTimeUnitEnum();

                            state._fsp--;


                            							if (current==null) {
                            								current = createModelElementForParent(grammarAccess.getSignalRule());
                            							}
                            							set(
                            								current,
                            								"scale",
                            								lv_scale_8_0,
                            								"org.eclipse.trace4cps.tl.Etl.TimeUnitEnum");
                            							afterParserOrEnumRuleCall();
                            						

                            }


                            }


                            }
                            break;

                    }

                    // InternalEtl.g:523:4: ( (lv_convSpec_9_0= ruleConvSpec ) )?
                    int alt7=2;
                    int LA7_0 = input.LA(1);

                    if ( (LA7_0==29) ) {
                        alt7=1;
                    }
                    switch (alt7) {
                        case 1 :
                            // InternalEtl.g:524:5: (lv_convSpec_9_0= ruleConvSpec )
                            {
                            // InternalEtl.g:524:5: (lv_convSpec_9_0= ruleConvSpec )
                            // InternalEtl.g:525:6: lv_convSpec_9_0= ruleConvSpec
                            {

                            						newCompositeNode(grammarAccess.getSignalAccess().getConvSpecConvSpecParserRuleCall_1_5_0());
                            					
                            pushFollow(FOLLOW_2);
                            lv_convSpec_9_0=ruleConvSpec();

                            state._fsp--;


                            						if (current==null) {
                            							current = createModelElementForParent(grammarAccess.getSignalRule());
                            						}
                            						set(
                            							current,
                            							"convSpec",
                            							lv_convSpec_9_0,
                            							"org.eclipse.trace4cps.tl.Etl.ConvSpec");
                            						afterParserOrEnumRuleCall();
                            					

                            }


                            }
                            break;

                    }


                    }


                    }
                    break;
                case 3 :
                    // InternalEtl.g:544:3: ( () otherlv_11= 'latency' otherlv_12= 'of' ( (lv_idAtt_13_0= RULE_ID ) ) (otherlv_14= 'in' ( (lv_scale_15_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_16_0= ruleConvSpec ) )? )
                    {
                    // InternalEtl.g:544:3: ( () otherlv_11= 'latency' otherlv_12= 'of' ( (lv_idAtt_13_0= RULE_ID ) ) (otherlv_14= 'in' ( (lv_scale_15_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_16_0= ruleConvSpec ) )? )
                    // InternalEtl.g:545:4: () otherlv_11= 'latency' otherlv_12= 'of' ( (lv_idAtt_13_0= RULE_ID ) ) (otherlv_14= 'in' ( (lv_scale_15_0= ruleTimeUnitEnum ) ) )? ( (lv_convSpec_16_0= ruleConvSpec ) )?
                    {
                    // InternalEtl.g:545:4: ()
                    // InternalEtl.g:546:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getSignalAccess().getLatencySignalAction_2_0(),
                    						current);
                    				

                    }

                    otherlv_11=(Token)match(input,24,FOLLOW_14); 

                    				newLeafNode(otherlv_11, grammarAccess.getSignalAccess().getLatencyKeyword_2_1());
                    			
                    otherlv_12=(Token)match(input,22,FOLLOW_4); 

                    				newLeafNode(otherlv_12, grammarAccess.getSignalAccess().getOfKeyword_2_2());
                    			
                    // InternalEtl.g:560:4: ( (lv_idAtt_13_0= RULE_ID ) )
                    // InternalEtl.g:561:5: (lv_idAtt_13_0= RULE_ID )
                    {
                    // InternalEtl.g:561:5: (lv_idAtt_13_0= RULE_ID )
                    // InternalEtl.g:562:6: lv_idAtt_13_0= RULE_ID
                    {
                    lv_idAtt_13_0=(Token)match(input,RULE_ID,FOLLOW_19); 

                    						newLeafNode(lv_idAtt_13_0, grammarAccess.getSignalAccess().getIdAttIDTerminalRuleCall_2_3_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getSignalRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"idAtt",
                    							lv_idAtt_13_0,
                    							"org.eclipse.xtext.common.Terminals.ID");
                    					

                    }


                    }

                    // InternalEtl.g:578:4: (otherlv_14= 'in' ( (lv_scale_15_0= ruleTimeUnitEnum ) ) )?
                    int alt8=2;
                    int LA8_0 = input.LA(1);

                    if ( (LA8_0==25) ) {
                        alt8=1;
                    }
                    switch (alt8) {
                        case 1 :
                            // InternalEtl.g:579:5: otherlv_14= 'in' ( (lv_scale_15_0= ruleTimeUnitEnum ) )
                            {
                            otherlv_14=(Token)match(input,25,FOLLOW_17); 

                            					newLeafNode(otherlv_14, grammarAccess.getSignalAccess().getInKeyword_2_4_0());
                            				
                            // InternalEtl.g:583:5: ( (lv_scale_15_0= ruleTimeUnitEnum ) )
                            // InternalEtl.g:584:6: (lv_scale_15_0= ruleTimeUnitEnum )
                            {
                            // InternalEtl.g:584:6: (lv_scale_15_0= ruleTimeUnitEnum )
                            // InternalEtl.g:585:7: lv_scale_15_0= ruleTimeUnitEnum
                            {

                            							newCompositeNode(grammarAccess.getSignalAccess().getScaleTimeUnitEnumEnumRuleCall_2_4_1_0());
                            						
                            pushFollow(FOLLOW_18);
                            lv_scale_15_0=ruleTimeUnitEnum();

                            state._fsp--;


                            							if (current==null) {
                            								current = createModelElementForParent(grammarAccess.getSignalRule());
                            							}
                            							set(
                            								current,
                            								"scale",
                            								lv_scale_15_0,
                            								"org.eclipse.trace4cps.tl.Etl.TimeUnitEnum");
                            							afterParserOrEnumRuleCall();
                            						

                            }


                            }


                            }
                            break;

                    }

                    // InternalEtl.g:603:4: ( (lv_convSpec_16_0= ruleConvSpec ) )?
                    int alt9=2;
                    int LA9_0 = input.LA(1);

                    if ( (LA9_0==29) ) {
                        alt9=1;
                    }
                    switch (alt9) {
                        case 1 :
                            // InternalEtl.g:604:5: (lv_convSpec_16_0= ruleConvSpec )
                            {
                            // InternalEtl.g:604:5: (lv_convSpec_16_0= ruleConvSpec )
                            // InternalEtl.g:605:6: lv_convSpec_16_0= ruleConvSpec
                            {

                            						newCompositeNode(grammarAccess.getSignalAccess().getConvSpecConvSpecParserRuleCall_2_5_0());
                            					
                            pushFollow(FOLLOW_2);
                            lv_convSpec_16_0=ruleConvSpec();

                            state._fsp--;


                            						if (current==null) {
                            							current = createModelElementForParent(grammarAccess.getSignalRule());
                            						}
                            						set(
                            							current,
                            							"convSpec",
                            							lv_convSpec_16_0,
                            							"org.eclipse.trace4cps.tl.Etl.ConvSpec");
                            						afterParserOrEnumRuleCall();
                            					

                            }


                            }
                            break;

                    }


                    }


                    }
                    break;
                case 4 :
                    // InternalEtl.g:624:3: ( () otherlv_18= 'wip' otherlv_19= 'of' ( (lv_idAtt_20_0= RULE_ID ) ) ( (lv_convSpec_21_0= ruleConvSpec ) )? )
                    {
                    // InternalEtl.g:624:3: ( () otherlv_18= 'wip' otherlv_19= 'of' ( (lv_idAtt_20_0= RULE_ID ) ) ( (lv_convSpec_21_0= ruleConvSpec ) )? )
                    // InternalEtl.g:625:4: () otherlv_18= 'wip' otherlv_19= 'of' ( (lv_idAtt_20_0= RULE_ID ) ) ( (lv_convSpec_21_0= ruleConvSpec ) )?
                    {
                    // InternalEtl.g:625:4: ()
                    // InternalEtl.g:626:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getSignalAccess().getWipSignalAction_3_0(),
                    						current);
                    				

                    }

                    otherlv_18=(Token)match(input,26,FOLLOW_14); 

                    				newLeafNode(otherlv_18, grammarAccess.getSignalAccess().getWipKeyword_3_1());
                    			
                    otherlv_19=(Token)match(input,22,FOLLOW_4); 

                    				newLeafNode(otherlv_19, grammarAccess.getSignalAccess().getOfKeyword_3_2());
                    			
                    // InternalEtl.g:640:4: ( (lv_idAtt_20_0= RULE_ID ) )
                    // InternalEtl.g:641:5: (lv_idAtt_20_0= RULE_ID )
                    {
                    // InternalEtl.g:641:5: (lv_idAtt_20_0= RULE_ID )
                    // InternalEtl.g:642:6: lv_idAtt_20_0= RULE_ID
                    {
                    lv_idAtt_20_0=(Token)match(input,RULE_ID,FOLLOW_18); 

                    						newLeafNode(lv_idAtt_20_0, grammarAccess.getSignalAccess().getIdAttIDTerminalRuleCall_3_3_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getSignalRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"idAtt",
                    							lv_idAtt_20_0,
                    							"org.eclipse.xtext.common.Terminals.ID");
                    					

                    }


                    }

                    // InternalEtl.g:658:4: ( (lv_convSpec_21_0= ruleConvSpec ) )?
                    int alt10=2;
                    int LA10_0 = input.LA(1);

                    if ( (LA10_0==29) ) {
                        alt10=1;
                    }
                    switch (alt10) {
                        case 1 :
                            // InternalEtl.g:659:5: (lv_convSpec_21_0= ruleConvSpec )
                            {
                            // InternalEtl.g:659:5: (lv_convSpec_21_0= ruleConvSpec )
                            // InternalEtl.g:660:6: lv_convSpec_21_0= ruleConvSpec
                            {

                            						newCompositeNode(grammarAccess.getSignalAccess().getConvSpecConvSpecParserRuleCall_3_4_0());
                            					
                            pushFollow(FOLLOW_2);
                            lv_convSpec_21_0=ruleConvSpec();

                            state._fsp--;


                            						if (current==null) {
                            							current = createModelElementForParent(grammarAccess.getSignalRule());
                            						}
                            						set(
                            							current,
                            							"convSpec",
                            							lv_convSpec_21_0,
                            							"org.eclipse.trace4cps.tl.Etl.ConvSpec");
                            						afterParserOrEnumRuleCall();
                            					

                            }


                            }
                            break;

                    }


                    }


                    }
                    break;
                case 5 :
                    // InternalEtl.g:679:3: ( () otherlv_23= 'resource-amount' ( (lv_filter_24_0= ruleAttributeFilter ) ) ( (lv_convSpec_25_0= ruleConvSpec ) )? )
                    {
                    // InternalEtl.g:679:3: ( () otherlv_23= 'resource-amount' ( (lv_filter_24_0= ruleAttributeFilter ) ) ( (lv_convSpec_25_0= ruleConvSpec ) )? )
                    // InternalEtl.g:680:4: () otherlv_23= 'resource-amount' ( (lv_filter_24_0= ruleAttributeFilter ) ) ( (lv_convSpec_25_0= ruleConvSpec ) )?
                    {
                    // InternalEtl.g:680:4: ()
                    // InternalEtl.g:681:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getSignalAccess().getResourceAmountSignalAction_4_0(),
                    						current);
                    				

                    }

                    otherlv_23=(Token)match(input,27,FOLLOW_20); 

                    				newLeafNode(otherlv_23, grammarAccess.getSignalAccess().getResourceAmountKeyword_4_1());
                    			
                    // InternalEtl.g:691:4: ( (lv_filter_24_0= ruleAttributeFilter ) )
                    // InternalEtl.g:692:5: (lv_filter_24_0= ruleAttributeFilter )
                    {
                    // InternalEtl.g:692:5: (lv_filter_24_0= ruleAttributeFilter )
                    // InternalEtl.g:693:6: lv_filter_24_0= ruleAttributeFilter
                    {

                    						newCompositeNode(grammarAccess.getSignalAccess().getFilterAttributeFilterParserRuleCall_4_2_0());
                    					
                    pushFollow(FOLLOW_18);
                    lv_filter_24_0=ruleAttributeFilter();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getSignalRule());
                    						}
                    						set(
                    							current,
                    							"filter",
                    							lv_filter_24_0,
                    							"org.eclipse.trace4cps.tl.Etl.AttributeFilter");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    // InternalEtl.g:710:4: ( (lv_convSpec_25_0= ruleConvSpec ) )?
                    int alt11=2;
                    int LA11_0 = input.LA(1);

                    if ( (LA11_0==29) ) {
                        alt11=1;
                    }
                    switch (alt11) {
                        case 1 :
                            // InternalEtl.g:711:5: (lv_convSpec_25_0= ruleConvSpec )
                            {
                            // InternalEtl.g:711:5: (lv_convSpec_25_0= ruleConvSpec )
                            // InternalEtl.g:712:6: lv_convSpec_25_0= ruleConvSpec
                            {

                            						newCompositeNode(grammarAccess.getSignalAccess().getConvSpecConvSpecParserRuleCall_4_3_0());
                            					
                            pushFollow(FOLLOW_2);
                            lv_convSpec_25_0=ruleConvSpec();

                            state._fsp--;


                            						if (current==null) {
                            							current = createModelElementForParent(grammarAccess.getSignalRule());
                            						}
                            						set(
                            							current,
                            							"convSpec",
                            							lv_convSpec_25_0,
                            							"org.eclipse.trace4cps.tl.Etl.ConvSpec");
                            						afterParserOrEnumRuleCall();
                            					

                            }


                            }
                            break;

                    }


                    }


                    }
                    break;
                case 6 :
                    // InternalEtl.g:731:3: ( () otherlv_27= 'resource-clients' ( (lv_filter_28_0= ruleAttributeFilter ) ) ( (lv_convSpec_29_0= ruleConvSpec ) )? )
                    {
                    // InternalEtl.g:731:3: ( () otherlv_27= 'resource-clients' ( (lv_filter_28_0= ruleAttributeFilter ) ) ( (lv_convSpec_29_0= ruleConvSpec ) )? )
                    // InternalEtl.g:732:4: () otherlv_27= 'resource-clients' ( (lv_filter_28_0= ruleAttributeFilter ) ) ( (lv_convSpec_29_0= ruleConvSpec ) )?
                    {
                    // InternalEtl.g:732:4: ()
                    // InternalEtl.g:733:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getSignalAccess().getResourceClientSignalAction_5_0(),
                    						current);
                    				

                    }

                    otherlv_27=(Token)match(input,28,FOLLOW_20); 

                    				newLeafNode(otherlv_27, grammarAccess.getSignalAccess().getResourceClientsKeyword_5_1());
                    			
                    // InternalEtl.g:743:4: ( (lv_filter_28_0= ruleAttributeFilter ) )
                    // InternalEtl.g:744:5: (lv_filter_28_0= ruleAttributeFilter )
                    {
                    // InternalEtl.g:744:5: (lv_filter_28_0= ruleAttributeFilter )
                    // InternalEtl.g:745:6: lv_filter_28_0= ruleAttributeFilter
                    {

                    						newCompositeNode(grammarAccess.getSignalAccess().getFilterAttributeFilterParserRuleCall_5_2_0());
                    					
                    pushFollow(FOLLOW_18);
                    lv_filter_28_0=ruleAttributeFilter();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getSignalRule());
                    						}
                    						set(
                    							current,
                    							"filter",
                    							lv_filter_28_0,
                    							"org.eclipse.trace4cps.tl.Etl.AttributeFilter");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    // InternalEtl.g:762:4: ( (lv_convSpec_29_0= ruleConvSpec ) )?
                    int alt12=2;
                    int LA12_0 = input.LA(1);

                    if ( (LA12_0==29) ) {
                        alt12=1;
                    }
                    switch (alt12) {
                        case 1 :
                            // InternalEtl.g:763:5: (lv_convSpec_29_0= ruleConvSpec )
                            {
                            // InternalEtl.g:763:5: (lv_convSpec_29_0= ruleConvSpec )
                            // InternalEtl.g:764:6: lv_convSpec_29_0= ruleConvSpec
                            {

                            						newCompositeNode(grammarAccess.getSignalAccess().getConvSpecConvSpecParserRuleCall_5_3_0());
                            					
                            pushFollow(FOLLOW_2);
                            lv_convSpec_29_0=ruleConvSpec();

                            state._fsp--;


                            						if (current==null) {
                            							current = createModelElementForParent(grammarAccess.getSignalRule());
                            						}
                            						set(
                            							current,
                            							"convSpec",
                            							lv_convSpec_29_0,
                            							"org.eclipse.trace4cps.tl.Etl.ConvSpec");
                            						afterParserOrEnumRuleCall();
                            					

                            }


                            }
                            break;

                    }


                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSignal"


    // $ANTLR start "entryRuleConvSpec"
    // InternalEtl.g:786:1: entryRuleConvSpec returns [EObject current=null] : iv_ruleConvSpec= ruleConvSpec EOF ;
    public final EObject entryRuleConvSpec() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleConvSpec = null;


        try {
            // InternalEtl.g:786:49: (iv_ruleConvSpec= ruleConvSpec EOF )
            // InternalEtl.g:787:2: iv_ruleConvSpec= ruleConvSpec EOF
            {
             newCompositeNode(grammarAccess.getConvSpecRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleConvSpec=ruleConvSpec();

            state._fsp--;

             current =iv_ruleConvSpec; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleConvSpec"


    // $ANTLR start "ruleConvSpec"
    // InternalEtl.g:793:1: ruleConvSpec returns [EObject current=null] : (otherlv_0= 'over' ( (lv_windowWidth_1_0= RULE_DOUBLE_T ) ) ( (lv_windowUnit_2_0= ruleTimeUnitEnum ) ) ) ;
    public final EObject ruleConvSpec() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_windowWidth_1_0=null;
        Enumerator lv_windowUnit_2_0 = null;



        	enterRule();

        try {
            // InternalEtl.g:799:2: ( (otherlv_0= 'over' ( (lv_windowWidth_1_0= RULE_DOUBLE_T ) ) ( (lv_windowUnit_2_0= ruleTimeUnitEnum ) ) ) )
            // InternalEtl.g:800:2: (otherlv_0= 'over' ( (lv_windowWidth_1_0= RULE_DOUBLE_T ) ) ( (lv_windowUnit_2_0= ruleTimeUnitEnum ) ) )
            {
            // InternalEtl.g:800:2: (otherlv_0= 'over' ( (lv_windowWidth_1_0= RULE_DOUBLE_T ) ) ( (lv_windowUnit_2_0= ruleTimeUnitEnum ) ) )
            // InternalEtl.g:801:3: otherlv_0= 'over' ( (lv_windowWidth_1_0= RULE_DOUBLE_T ) ) ( (lv_windowUnit_2_0= ruleTimeUnitEnum ) )
            {
            otherlv_0=(Token)match(input,29,FOLLOW_21); 

            			newLeafNode(otherlv_0, grammarAccess.getConvSpecAccess().getOverKeyword_0());
            		
            // InternalEtl.g:805:3: ( (lv_windowWidth_1_0= RULE_DOUBLE_T ) )
            // InternalEtl.g:806:4: (lv_windowWidth_1_0= RULE_DOUBLE_T )
            {
            // InternalEtl.g:806:4: (lv_windowWidth_1_0= RULE_DOUBLE_T )
            // InternalEtl.g:807:5: lv_windowWidth_1_0= RULE_DOUBLE_T
            {
            lv_windowWidth_1_0=(Token)match(input,RULE_DOUBLE_T,FOLLOW_17); 

            					newLeafNode(lv_windowWidth_1_0, grammarAccess.getConvSpecAccess().getWindowWidthDOUBLE_TTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getConvSpecRule());
            					}
            					setWithLastConsumed(
            						current,
            						"windowWidth",
            						lv_windowWidth_1_0,
            						"org.eclipse.trace4cps.tl.Etl.DOUBLE_T");
            				

            }


            }

            // InternalEtl.g:823:3: ( (lv_windowUnit_2_0= ruleTimeUnitEnum ) )
            // InternalEtl.g:824:4: (lv_windowUnit_2_0= ruleTimeUnitEnum )
            {
            // InternalEtl.g:824:4: (lv_windowUnit_2_0= ruleTimeUnitEnum )
            // InternalEtl.g:825:5: lv_windowUnit_2_0= ruleTimeUnitEnum
            {

            					newCompositeNode(grammarAccess.getConvSpecAccess().getWindowUnitTimeUnitEnumEnumRuleCall_2_0());
            				
            pushFollow(FOLLOW_2);
            lv_windowUnit_2_0=ruleTimeUnitEnum();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getConvSpecRule());
            					}
            					set(
            						current,
            						"windowUnit",
            						lv_windowUnit_2_0,
            						"org.eclipse.trace4cps.tl.Etl.TimeUnitEnum");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleConvSpec"


    // $ANTLR start "entryRuleFormula"
    // InternalEtl.g:846:1: entryRuleFormula returns [EObject current=null] : iv_ruleFormula= ruleFormula EOF ;
    public final EObject entryRuleFormula() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleFormula = null;


        try {
            // InternalEtl.g:846:48: (iv_ruleFormula= ruleFormula EOF )
            // InternalEtl.g:847:2: iv_ruleFormula= ruleFormula EOF
            {
             newCompositeNode(grammarAccess.getFormulaRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleFormula=ruleFormula();

            state._fsp--;

             current =iv_ruleFormula; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFormula"


    // $ANTLR start "ruleFormula"
    // InternalEtl.g:853:1: ruleFormula returns [EObject current=null] : ( ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_param_3_0= RULE_ID ) ) (otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) ) )? otherlv_6= ')' )? ) | ( () ( (lv_mtlAP_8_0= ruleMtlAp ) ) ) | ( () ( (lv_stlAP_10_0= ruleStlAp ) ) ) | ( () otherlv_12= 'not' ( (lv_formula_13_0= ruleFormula ) ) ) | ( () otherlv_15= '(' ( (lv_left_16_0= ruleFormula ) ) ( (lv_op_17_0= ruleAndOr ) ) ( (lv_right_18_0= ruleFormula ) ) otherlv_19= ')' ) | ( () otherlv_21= 'if' ( (lv_left_22_0= ruleFormula ) ) otherlv_23= 'then' ( (lv_right_24_0= ruleFormula ) ) ) | ( () otherlv_26= 'globally' ( (lv_formula_27_0= ruleFormula ) ) ) | ( () otherlv_29= 'during' ( (lv_interval_30_0= ruleInterval ) ) ( (lv_formula_31_0= ruleFormula ) ) ) | ( () otherlv_33= 'finally' ( (lv_formula_34_0= ruleFormula ) ) ) | ( () otherlv_36= 'within' ( (lv_interval_37_0= ruleInterval ) ) ( (lv_formula_38_0= ruleFormula ) ) ) | ( () otherlv_40= 'until' ( (lv_right_41_0= ruleFormula ) ) otherlv_42= 'we' otherlv_43= 'have' otherlv_44= 'that' ( (lv_left_45_0= ruleFormula ) ) ) | ( () otherlv_47= 'by' ( (lv_interval_48_0= ruleInterval ) ) ( (lv_right_49_0= ruleFormula ) ) otherlv_50= 'and' otherlv_51= 'until' otherlv_52= 'then' ( (lv_left_53_0= ruleFormula ) ) ) ) ;
    public final EObject ruleFormula() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_2=null;
        Token lv_param_3_0=null;
        Token otherlv_4=null;
        Token lv_val_5_0=null;
        Token otherlv_6=null;
        Token otherlv_12=null;
        Token otherlv_15=null;
        Token otherlv_19=null;
        Token otherlv_21=null;
        Token otherlv_23=null;
        Token otherlv_26=null;
        Token otherlv_29=null;
        Token otherlv_33=null;
        Token otherlv_36=null;
        Token otherlv_40=null;
        Token otherlv_42=null;
        Token otherlv_43=null;
        Token otherlv_44=null;
        Token otherlv_47=null;
        Token otherlv_50=null;
        Token otherlv_51=null;
        Token otherlv_52=null;
        EObject lv_mtlAP_8_0 = null;

        EObject lv_stlAP_10_0 = null;

        EObject lv_formula_13_0 = null;

        EObject lv_left_16_0 = null;

        Enumerator lv_op_17_0 = null;

        EObject lv_right_18_0 = null;

        EObject lv_left_22_0 = null;

        EObject lv_right_24_0 = null;

        EObject lv_formula_27_0 = null;

        EObject lv_interval_30_0 = null;

        EObject lv_formula_31_0 = null;

        EObject lv_formula_34_0 = null;

        EObject lv_interval_37_0 = null;

        EObject lv_formula_38_0 = null;

        EObject lv_right_41_0 = null;

        EObject lv_left_45_0 = null;

        EObject lv_interval_48_0 = null;

        EObject lv_right_49_0 = null;

        EObject lv_left_53_0 = null;



        	enterRule();

        try {
            // InternalEtl.g:859:2: ( ( ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_param_3_0= RULE_ID ) ) (otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) ) )? otherlv_6= ')' )? ) | ( () ( (lv_mtlAP_8_0= ruleMtlAp ) ) ) | ( () ( (lv_stlAP_10_0= ruleStlAp ) ) ) | ( () otherlv_12= 'not' ( (lv_formula_13_0= ruleFormula ) ) ) | ( () otherlv_15= '(' ( (lv_left_16_0= ruleFormula ) ) ( (lv_op_17_0= ruleAndOr ) ) ( (lv_right_18_0= ruleFormula ) ) otherlv_19= ')' ) | ( () otherlv_21= 'if' ( (lv_left_22_0= ruleFormula ) ) otherlv_23= 'then' ( (lv_right_24_0= ruleFormula ) ) ) | ( () otherlv_26= 'globally' ( (lv_formula_27_0= ruleFormula ) ) ) | ( () otherlv_29= 'during' ( (lv_interval_30_0= ruleInterval ) ) ( (lv_formula_31_0= ruleFormula ) ) ) | ( () otherlv_33= 'finally' ( (lv_formula_34_0= ruleFormula ) ) ) | ( () otherlv_36= 'within' ( (lv_interval_37_0= ruleInterval ) ) ( (lv_formula_38_0= ruleFormula ) ) ) | ( () otherlv_40= 'until' ( (lv_right_41_0= ruleFormula ) ) otherlv_42= 'we' otherlv_43= 'have' otherlv_44= 'that' ( (lv_left_45_0= ruleFormula ) ) ) | ( () otherlv_47= 'by' ( (lv_interval_48_0= ruleInterval ) ) ( (lv_right_49_0= ruleFormula ) ) otherlv_50= 'and' otherlv_51= 'until' otherlv_52= 'then' ( (lv_left_53_0= ruleFormula ) ) ) ) )
            // InternalEtl.g:860:2: ( ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_param_3_0= RULE_ID ) ) (otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) ) )? otherlv_6= ')' )? ) | ( () ( (lv_mtlAP_8_0= ruleMtlAp ) ) ) | ( () ( (lv_stlAP_10_0= ruleStlAp ) ) ) | ( () otherlv_12= 'not' ( (lv_formula_13_0= ruleFormula ) ) ) | ( () otherlv_15= '(' ( (lv_left_16_0= ruleFormula ) ) ( (lv_op_17_0= ruleAndOr ) ) ( (lv_right_18_0= ruleFormula ) ) otherlv_19= ')' ) | ( () otherlv_21= 'if' ( (lv_left_22_0= ruleFormula ) ) otherlv_23= 'then' ( (lv_right_24_0= ruleFormula ) ) ) | ( () otherlv_26= 'globally' ( (lv_formula_27_0= ruleFormula ) ) ) | ( () otherlv_29= 'during' ( (lv_interval_30_0= ruleInterval ) ) ( (lv_formula_31_0= ruleFormula ) ) ) | ( () otherlv_33= 'finally' ( (lv_formula_34_0= ruleFormula ) ) ) | ( () otherlv_36= 'within' ( (lv_interval_37_0= ruleInterval ) ) ( (lv_formula_38_0= ruleFormula ) ) ) | ( () otherlv_40= 'until' ( (lv_right_41_0= ruleFormula ) ) otherlv_42= 'we' otherlv_43= 'have' otherlv_44= 'that' ( (lv_left_45_0= ruleFormula ) ) ) | ( () otherlv_47= 'by' ( (lv_interval_48_0= ruleInterval ) ) ( (lv_right_49_0= ruleFormula ) ) otherlv_50= 'and' otherlv_51= 'until' otherlv_52= 'then' ( (lv_left_53_0= ruleFormula ) ) ) )
            {
            // InternalEtl.g:860:2: ( ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_param_3_0= RULE_ID ) ) (otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) ) )? otherlv_6= ')' )? ) | ( () ( (lv_mtlAP_8_0= ruleMtlAp ) ) ) | ( () ( (lv_stlAP_10_0= ruleStlAp ) ) ) | ( () otherlv_12= 'not' ( (lv_formula_13_0= ruleFormula ) ) ) | ( () otherlv_15= '(' ( (lv_left_16_0= ruleFormula ) ) ( (lv_op_17_0= ruleAndOr ) ) ( (lv_right_18_0= ruleFormula ) ) otherlv_19= ')' ) | ( () otherlv_21= 'if' ( (lv_left_22_0= ruleFormula ) ) otherlv_23= 'then' ( (lv_right_24_0= ruleFormula ) ) ) | ( () otherlv_26= 'globally' ( (lv_formula_27_0= ruleFormula ) ) ) | ( () otherlv_29= 'during' ( (lv_interval_30_0= ruleInterval ) ) ( (lv_formula_31_0= ruleFormula ) ) ) | ( () otherlv_33= 'finally' ( (lv_formula_34_0= ruleFormula ) ) ) | ( () otherlv_36= 'within' ( (lv_interval_37_0= ruleInterval ) ) ( (lv_formula_38_0= ruleFormula ) ) ) | ( () otherlv_40= 'until' ( (lv_right_41_0= ruleFormula ) ) otherlv_42= 'we' otherlv_43= 'have' otherlv_44= 'that' ( (lv_left_45_0= ruleFormula ) ) ) | ( () otherlv_47= 'by' ( (lv_interval_48_0= ruleInterval ) ) ( (lv_right_49_0= ruleFormula ) ) otherlv_50= 'and' otherlv_51= 'until' otherlv_52= 'then' ( (lv_left_53_0= ruleFormula ) ) ) )
            int alt16=12;
            alt16 = dfa16.predict(input);
            switch (alt16) {
                case 1 :
                    // InternalEtl.g:861:3: ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_param_3_0= RULE_ID ) ) (otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) ) )? otherlv_6= ')' )? )
                    {
                    // InternalEtl.g:861:3: ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_param_3_0= RULE_ID ) ) (otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) ) )? otherlv_6= ')' )? )
                    // InternalEtl.g:862:4: () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_param_3_0= RULE_ID ) ) (otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) ) )? otherlv_6= ')' )?
                    {
                    // InternalEtl.g:862:4: ()
                    // InternalEtl.g:863:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getReferenceFormulaAction_0_0(),
                    						current);
                    				

                    }

                    // InternalEtl.g:869:4: ( (otherlv_1= RULE_ID ) )
                    // InternalEtl.g:870:5: (otherlv_1= RULE_ID )
                    {
                    // InternalEtl.g:870:5: (otherlv_1= RULE_ID )
                    // InternalEtl.g:871:6: otherlv_1= RULE_ID
                    {

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getFormulaRule());
                    						}
                    					
                    otherlv_1=(Token)match(input,RULE_ID,FOLLOW_22); 

                    						newLeafNode(otherlv_1, grammarAccess.getFormulaAccess().getDefDefCrossReference_0_1_0());
                    					

                    }


                    }

                    // InternalEtl.g:882:4: (otherlv_2= '(' ( (lv_param_3_0= RULE_ID ) ) (otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) ) )? otherlv_6= ')' )?
                    int alt15=2;
                    int LA15_0 = input.LA(1);

                    if ( (LA15_0==16) ) {
                        alt15=1;
                    }
                    switch (alt15) {
                        case 1 :
                            // InternalEtl.g:883:5: otherlv_2= '(' ( (lv_param_3_0= RULE_ID ) ) (otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) ) )? otherlv_6= ')'
                            {
                            otherlv_2=(Token)match(input,16,FOLLOW_4); 

                            					newLeafNode(otherlv_2, grammarAccess.getFormulaAccess().getLeftParenthesisKeyword_0_2_0());
                            				
                            // InternalEtl.g:887:5: ( (lv_param_3_0= RULE_ID ) )
                            // InternalEtl.g:888:6: (lv_param_3_0= RULE_ID )
                            {
                            // InternalEtl.g:888:6: (lv_param_3_0= RULE_ID )
                            // InternalEtl.g:889:7: lv_param_3_0= RULE_ID
                            {
                            lv_param_3_0=(Token)match(input,RULE_ID,FOLLOW_23); 

                            							newLeafNode(lv_param_3_0, grammarAccess.getFormulaAccess().getParamIDTerminalRuleCall_0_2_1_0());
                            						

                            							if (current==null) {
                            								current = createModelElement(grammarAccess.getFormulaRule());
                            							}
                            							setWithLastConsumed(
                            								current,
                            								"param",
                            								lv_param_3_0,
                            								"org.eclipse.xtext.common.Terminals.ID");
                            						

                            }


                            }

                            // InternalEtl.g:905:5: (otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) ) )?
                            int alt14=2;
                            int LA14_0 = input.LA(1);

                            if ( (LA14_0==30) ) {
                                alt14=1;
                            }
                            switch (alt14) {
                                case 1 :
                                    // InternalEtl.g:906:6: otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) )
                                    {
                                    otherlv_4=(Token)match(input,30,FOLLOW_12); 

                                    						newLeafNode(otherlv_4, grammarAccess.getFormulaAccess().getPlusSignKeyword_0_2_2_0());
                                    					
                                    // InternalEtl.g:910:6: ( (lv_val_5_0= RULE_INT_T ) )
                                    // InternalEtl.g:911:7: (lv_val_5_0= RULE_INT_T )
                                    {
                                    // InternalEtl.g:911:7: (lv_val_5_0= RULE_INT_T )
                                    // InternalEtl.g:912:8: lv_val_5_0= RULE_INT_T
                                    {
                                    lv_val_5_0=(Token)match(input,RULE_INT_T,FOLLOW_8); 

                                    								newLeafNode(lv_val_5_0, grammarAccess.getFormulaAccess().getValINT_TTerminalRuleCall_0_2_2_1_0());
                                    							

                                    								if (current==null) {
                                    									current = createModelElement(grammarAccess.getFormulaRule());
                                    								}
                                    								setWithLastConsumed(
                                    									current,
                                    									"val",
                                    									lv_val_5_0,
                                    									"org.eclipse.trace4cps.tl.Etl.INT_T");
                                    							

                                    }


                                    }


                                    }
                                    break;

                            }

                            otherlv_6=(Token)match(input,17,FOLLOW_2); 

                            					newLeafNode(otherlv_6, grammarAccess.getFormulaAccess().getRightParenthesisKeyword_0_2_3());
                            				

                            }
                            break;

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:936:3: ( () ( (lv_mtlAP_8_0= ruleMtlAp ) ) )
                    {
                    // InternalEtl.g:936:3: ( () ( (lv_mtlAP_8_0= ruleMtlAp ) ) )
                    // InternalEtl.g:937:4: () ( (lv_mtlAP_8_0= ruleMtlAp ) )
                    {
                    // InternalEtl.g:937:4: ()
                    // InternalEtl.g:938:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getApFormulaAction_1_0(),
                    						current);
                    				

                    }

                    // InternalEtl.g:944:4: ( (lv_mtlAP_8_0= ruleMtlAp ) )
                    // InternalEtl.g:945:5: (lv_mtlAP_8_0= ruleMtlAp )
                    {
                    // InternalEtl.g:945:5: (lv_mtlAP_8_0= ruleMtlAp )
                    // InternalEtl.g:946:6: lv_mtlAP_8_0= ruleMtlAp
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getMtlAPMtlApParserRuleCall_1_1_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_mtlAP_8_0=ruleMtlAp();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"mtlAP",
                    							lv_mtlAP_8_0,
                    							"org.eclipse.trace4cps.tl.Etl.MtlAp");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 3 :
                    // InternalEtl.g:965:3: ( () ( (lv_stlAP_10_0= ruleStlAp ) ) )
                    {
                    // InternalEtl.g:965:3: ( () ( (lv_stlAP_10_0= ruleStlAp ) ) )
                    // InternalEtl.g:966:4: () ( (lv_stlAP_10_0= ruleStlAp ) )
                    {
                    // InternalEtl.g:966:4: ()
                    // InternalEtl.g:967:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getApFormulaAction_2_0(),
                    						current);
                    				

                    }

                    // InternalEtl.g:973:4: ( (lv_stlAP_10_0= ruleStlAp ) )
                    // InternalEtl.g:974:5: (lv_stlAP_10_0= ruleStlAp )
                    {
                    // InternalEtl.g:974:5: (lv_stlAP_10_0= ruleStlAp )
                    // InternalEtl.g:975:6: lv_stlAP_10_0= ruleStlAp
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getStlAPStlApParserRuleCall_2_1_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_stlAP_10_0=ruleStlAp();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"stlAP",
                    							lv_stlAP_10_0,
                    							"org.eclipse.trace4cps.tl.Etl.StlAp");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 4 :
                    // InternalEtl.g:994:3: ( () otherlv_12= 'not' ( (lv_formula_13_0= ruleFormula ) ) )
                    {
                    // InternalEtl.g:994:3: ( () otherlv_12= 'not' ( (lv_formula_13_0= ruleFormula ) ) )
                    // InternalEtl.g:995:4: () otherlv_12= 'not' ( (lv_formula_13_0= ruleFormula ) )
                    {
                    // InternalEtl.g:995:4: ()
                    // InternalEtl.g:996:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getNotFormulaAction_3_0(),
                    						current);
                    				

                    }

                    otherlv_12=(Token)match(input,31,FOLLOW_9); 

                    				newLeafNode(otherlv_12, grammarAccess.getFormulaAccess().getNotKeyword_3_1());
                    			
                    // InternalEtl.g:1006:4: ( (lv_formula_13_0= ruleFormula ) )
                    // InternalEtl.g:1007:5: (lv_formula_13_0= ruleFormula )
                    {
                    // InternalEtl.g:1007:5: (lv_formula_13_0= ruleFormula )
                    // InternalEtl.g:1008:6: lv_formula_13_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getFormulaFormulaParserRuleCall_3_2_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_formula_13_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"formula",
                    							lv_formula_13_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 5 :
                    // InternalEtl.g:1027:3: ( () otherlv_15= '(' ( (lv_left_16_0= ruleFormula ) ) ( (lv_op_17_0= ruleAndOr ) ) ( (lv_right_18_0= ruleFormula ) ) otherlv_19= ')' )
                    {
                    // InternalEtl.g:1027:3: ( () otherlv_15= '(' ( (lv_left_16_0= ruleFormula ) ) ( (lv_op_17_0= ruleAndOr ) ) ( (lv_right_18_0= ruleFormula ) ) otherlv_19= ')' )
                    // InternalEtl.g:1028:4: () otherlv_15= '(' ( (lv_left_16_0= ruleFormula ) ) ( (lv_op_17_0= ruleAndOr ) ) ( (lv_right_18_0= ruleFormula ) ) otherlv_19= ')'
                    {
                    // InternalEtl.g:1028:4: ()
                    // InternalEtl.g:1029:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getAndOrFormulaAction_4_0(),
                    						current);
                    				

                    }

                    otherlv_15=(Token)match(input,16,FOLLOW_9); 

                    				newLeafNode(otherlv_15, grammarAccess.getFormulaAccess().getLeftParenthesisKeyword_4_1());
                    			
                    // InternalEtl.g:1039:4: ( (lv_left_16_0= ruleFormula ) )
                    // InternalEtl.g:1040:5: (lv_left_16_0= ruleFormula )
                    {
                    // InternalEtl.g:1040:5: (lv_left_16_0= ruleFormula )
                    // InternalEtl.g:1041:6: lv_left_16_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getLeftFormulaParserRuleCall_4_2_0());
                    					
                    pushFollow(FOLLOW_24);
                    lv_left_16_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"left",
                    							lv_left_16_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    // InternalEtl.g:1058:4: ( (lv_op_17_0= ruleAndOr ) )
                    // InternalEtl.g:1059:5: (lv_op_17_0= ruleAndOr )
                    {
                    // InternalEtl.g:1059:5: (lv_op_17_0= ruleAndOr )
                    // InternalEtl.g:1060:6: lv_op_17_0= ruleAndOr
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getOpAndOrEnumRuleCall_4_3_0());
                    					
                    pushFollow(FOLLOW_9);
                    lv_op_17_0=ruleAndOr();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"op",
                    							lv_op_17_0,
                    							"org.eclipse.trace4cps.tl.Etl.AndOr");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    // InternalEtl.g:1077:4: ( (lv_right_18_0= ruleFormula ) )
                    // InternalEtl.g:1078:5: (lv_right_18_0= ruleFormula )
                    {
                    // InternalEtl.g:1078:5: (lv_right_18_0= ruleFormula )
                    // InternalEtl.g:1079:6: lv_right_18_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getRightFormulaParserRuleCall_4_4_0());
                    					
                    pushFollow(FOLLOW_8);
                    lv_right_18_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"right",
                    							lv_right_18_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    otherlv_19=(Token)match(input,17,FOLLOW_2); 

                    				newLeafNode(otherlv_19, grammarAccess.getFormulaAccess().getRightParenthesisKeyword_4_5());
                    			

                    }


                    }
                    break;
                case 6 :
                    // InternalEtl.g:1102:3: ( () otherlv_21= 'if' ( (lv_left_22_0= ruleFormula ) ) otherlv_23= 'then' ( (lv_right_24_0= ruleFormula ) ) )
                    {
                    // InternalEtl.g:1102:3: ( () otherlv_21= 'if' ( (lv_left_22_0= ruleFormula ) ) otherlv_23= 'then' ( (lv_right_24_0= ruleFormula ) ) )
                    // InternalEtl.g:1103:4: () otherlv_21= 'if' ( (lv_left_22_0= ruleFormula ) ) otherlv_23= 'then' ( (lv_right_24_0= ruleFormula ) )
                    {
                    // InternalEtl.g:1103:4: ()
                    // InternalEtl.g:1104:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getIfThenFormulaAction_5_0(),
                    						current);
                    				

                    }

                    otherlv_21=(Token)match(input,32,FOLLOW_9); 

                    				newLeafNode(otherlv_21, grammarAccess.getFormulaAccess().getIfKeyword_5_1());
                    			
                    // InternalEtl.g:1114:4: ( (lv_left_22_0= ruleFormula ) )
                    // InternalEtl.g:1115:5: (lv_left_22_0= ruleFormula )
                    {
                    // InternalEtl.g:1115:5: (lv_left_22_0= ruleFormula )
                    // InternalEtl.g:1116:6: lv_left_22_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getLeftFormulaParserRuleCall_5_2_0());
                    					
                    pushFollow(FOLLOW_25);
                    lv_left_22_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"left",
                    							lv_left_22_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    otherlv_23=(Token)match(input,33,FOLLOW_9); 

                    				newLeafNode(otherlv_23, grammarAccess.getFormulaAccess().getThenKeyword_5_3());
                    			
                    // InternalEtl.g:1137:4: ( (lv_right_24_0= ruleFormula ) )
                    // InternalEtl.g:1138:5: (lv_right_24_0= ruleFormula )
                    {
                    // InternalEtl.g:1138:5: (lv_right_24_0= ruleFormula )
                    // InternalEtl.g:1139:6: lv_right_24_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getRightFormulaParserRuleCall_5_4_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_right_24_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"right",
                    							lv_right_24_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 7 :
                    // InternalEtl.g:1158:3: ( () otherlv_26= 'globally' ( (lv_formula_27_0= ruleFormula ) ) )
                    {
                    // InternalEtl.g:1158:3: ( () otherlv_26= 'globally' ( (lv_formula_27_0= ruleFormula ) ) )
                    // InternalEtl.g:1159:4: () otherlv_26= 'globally' ( (lv_formula_27_0= ruleFormula ) )
                    {
                    // InternalEtl.g:1159:4: ()
                    // InternalEtl.g:1160:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getGloballyUntimedFormulaAction_6_0(),
                    						current);
                    				

                    }

                    otherlv_26=(Token)match(input,34,FOLLOW_9); 

                    				newLeafNode(otherlv_26, grammarAccess.getFormulaAccess().getGloballyKeyword_6_1());
                    			
                    // InternalEtl.g:1170:4: ( (lv_formula_27_0= ruleFormula ) )
                    // InternalEtl.g:1171:5: (lv_formula_27_0= ruleFormula )
                    {
                    // InternalEtl.g:1171:5: (lv_formula_27_0= ruleFormula )
                    // InternalEtl.g:1172:6: lv_formula_27_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getFormulaFormulaParserRuleCall_6_2_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_formula_27_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"formula",
                    							lv_formula_27_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 8 :
                    // InternalEtl.g:1191:3: ( () otherlv_29= 'during' ( (lv_interval_30_0= ruleInterval ) ) ( (lv_formula_31_0= ruleFormula ) ) )
                    {
                    // InternalEtl.g:1191:3: ( () otherlv_29= 'during' ( (lv_interval_30_0= ruleInterval ) ) ( (lv_formula_31_0= ruleFormula ) ) )
                    // InternalEtl.g:1192:4: () otherlv_29= 'during' ( (lv_interval_30_0= ruleInterval ) ) ( (lv_formula_31_0= ruleFormula ) )
                    {
                    // InternalEtl.g:1192:4: ()
                    // InternalEtl.g:1193:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getGloballyFormulaAction_7_0(),
                    						current);
                    				

                    }

                    otherlv_29=(Token)match(input,35,FOLLOW_26); 

                    				newLeafNode(otherlv_29, grammarAccess.getFormulaAccess().getDuringKeyword_7_1());
                    			
                    // InternalEtl.g:1203:4: ( (lv_interval_30_0= ruleInterval ) )
                    // InternalEtl.g:1204:5: (lv_interval_30_0= ruleInterval )
                    {
                    // InternalEtl.g:1204:5: (lv_interval_30_0= ruleInterval )
                    // InternalEtl.g:1205:6: lv_interval_30_0= ruleInterval
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getIntervalIntervalParserRuleCall_7_2_0());
                    					
                    pushFollow(FOLLOW_9);
                    lv_interval_30_0=ruleInterval();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"interval",
                    							lv_interval_30_0,
                    							"org.eclipse.trace4cps.tl.Etl.Interval");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    // InternalEtl.g:1222:4: ( (lv_formula_31_0= ruleFormula ) )
                    // InternalEtl.g:1223:5: (lv_formula_31_0= ruleFormula )
                    {
                    // InternalEtl.g:1223:5: (lv_formula_31_0= ruleFormula )
                    // InternalEtl.g:1224:6: lv_formula_31_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getFormulaFormulaParserRuleCall_7_3_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_formula_31_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"formula",
                    							lv_formula_31_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 9 :
                    // InternalEtl.g:1243:3: ( () otherlv_33= 'finally' ( (lv_formula_34_0= ruleFormula ) ) )
                    {
                    // InternalEtl.g:1243:3: ( () otherlv_33= 'finally' ( (lv_formula_34_0= ruleFormula ) ) )
                    // InternalEtl.g:1244:4: () otherlv_33= 'finally' ( (lv_formula_34_0= ruleFormula ) )
                    {
                    // InternalEtl.g:1244:4: ()
                    // InternalEtl.g:1245:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getFinallyUntimedFormulaAction_8_0(),
                    						current);
                    				

                    }

                    otherlv_33=(Token)match(input,36,FOLLOW_9); 

                    				newLeafNode(otherlv_33, grammarAccess.getFormulaAccess().getFinallyKeyword_8_1());
                    			
                    // InternalEtl.g:1255:4: ( (lv_formula_34_0= ruleFormula ) )
                    // InternalEtl.g:1256:5: (lv_formula_34_0= ruleFormula )
                    {
                    // InternalEtl.g:1256:5: (lv_formula_34_0= ruleFormula )
                    // InternalEtl.g:1257:6: lv_formula_34_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getFormulaFormulaParserRuleCall_8_2_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_formula_34_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"formula",
                    							lv_formula_34_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 10 :
                    // InternalEtl.g:1276:3: ( () otherlv_36= 'within' ( (lv_interval_37_0= ruleInterval ) ) ( (lv_formula_38_0= ruleFormula ) ) )
                    {
                    // InternalEtl.g:1276:3: ( () otherlv_36= 'within' ( (lv_interval_37_0= ruleInterval ) ) ( (lv_formula_38_0= ruleFormula ) ) )
                    // InternalEtl.g:1277:4: () otherlv_36= 'within' ( (lv_interval_37_0= ruleInterval ) ) ( (lv_formula_38_0= ruleFormula ) )
                    {
                    // InternalEtl.g:1277:4: ()
                    // InternalEtl.g:1278:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getFinallyFormulaAction_9_0(),
                    						current);
                    				

                    }

                    otherlv_36=(Token)match(input,37,FOLLOW_26); 

                    				newLeafNode(otherlv_36, grammarAccess.getFormulaAccess().getWithinKeyword_9_1());
                    			
                    // InternalEtl.g:1288:4: ( (lv_interval_37_0= ruleInterval ) )
                    // InternalEtl.g:1289:5: (lv_interval_37_0= ruleInterval )
                    {
                    // InternalEtl.g:1289:5: (lv_interval_37_0= ruleInterval )
                    // InternalEtl.g:1290:6: lv_interval_37_0= ruleInterval
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getIntervalIntervalParserRuleCall_9_2_0());
                    					
                    pushFollow(FOLLOW_9);
                    lv_interval_37_0=ruleInterval();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"interval",
                    							lv_interval_37_0,
                    							"org.eclipse.trace4cps.tl.Etl.Interval");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    // InternalEtl.g:1307:4: ( (lv_formula_38_0= ruleFormula ) )
                    // InternalEtl.g:1308:5: (lv_formula_38_0= ruleFormula )
                    {
                    // InternalEtl.g:1308:5: (lv_formula_38_0= ruleFormula )
                    // InternalEtl.g:1309:6: lv_formula_38_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getFormulaFormulaParserRuleCall_9_3_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_formula_38_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"formula",
                    							lv_formula_38_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 11 :
                    // InternalEtl.g:1328:3: ( () otherlv_40= 'until' ( (lv_right_41_0= ruleFormula ) ) otherlv_42= 'we' otherlv_43= 'have' otherlv_44= 'that' ( (lv_left_45_0= ruleFormula ) ) )
                    {
                    // InternalEtl.g:1328:3: ( () otherlv_40= 'until' ( (lv_right_41_0= ruleFormula ) ) otherlv_42= 'we' otherlv_43= 'have' otherlv_44= 'that' ( (lv_left_45_0= ruleFormula ) ) )
                    // InternalEtl.g:1329:4: () otherlv_40= 'until' ( (lv_right_41_0= ruleFormula ) ) otherlv_42= 'we' otherlv_43= 'have' otherlv_44= 'that' ( (lv_left_45_0= ruleFormula ) )
                    {
                    // InternalEtl.g:1329:4: ()
                    // InternalEtl.g:1330:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getUntilUntimedFormulaAction_10_0(),
                    						current);
                    				

                    }

                    otherlv_40=(Token)match(input,38,FOLLOW_9); 

                    				newLeafNode(otherlv_40, grammarAccess.getFormulaAccess().getUntilKeyword_10_1());
                    			
                    // InternalEtl.g:1340:4: ( (lv_right_41_0= ruleFormula ) )
                    // InternalEtl.g:1341:5: (lv_right_41_0= ruleFormula )
                    {
                    // InternalEtl.g:1341:5: (lv_right_41_0= ruleFormula )
                    // InternalEtl.g:1342:6: lv_right_41_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getRightFormulaParserRuleCall_10_2_0());
                    					
                    pushFollow(FOLLOW_27);
                    lv_right_41_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"right",
                    							lv_right_41_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    otherlv_42=(Token)match(input,39,FOLLOW_28); 

                    				newLeafNode(otherlv_42, grammarAccess.getFormulaAccess().getWeKeyword_10_3());
                    			
                    otherlv_43=(Token)match(input,40,FOLLOW_29); 

                    				newLeafNode(otherlv_43, grammarAccess.getFormulaAccess().getHaveKeyword_10_4());
                    			
                    otherlv_44=(Token)match(input,41,FOLLOW_9); 

                    				newLeafNode(otherlv_44, grammarAccess.getFormulaAccess().getThatKeyword_10_5());
                    			
                    // InternalEtl.g:1371:4: ( (lv_left_45_0= ruleFormula ) )
                    // InternalEtl.g:1372:5: (lv_left_45_0= ruleFormula )
                    {
                    // InternalEtl.g:1372:5: (lv_left_45_0= ruleFormula )
                    // InternalEtl.g:1373:6: lv_left_45_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getLeftFormulaParserRuleCall_10_6_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_left_45_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"left",
                    							lv_left_45_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;
                case 12 :
                    // InternalEtl.g:1392:3: ( () otherlv_47= 'by' ( (lv_interval_48_0= ruleInterval ) ) ( (lv_right_49_0= ruleFormula ) ) otherlv_50= 'and' otherlv_51= 'until' otherlv_52= 'then' ( (lv_left_53_0= ruleFormula ) ) )
                    {
                    // InternalEtl.g:1392:3: ( () otherlv_47= 'by' ( (lv_interval_48_0= ruleInterval ) ) ( (lv_right_49_0= ruleFormula ) ) otherlv_50= 'and' otherlv_51= 'until' otherlv_52= 'then' ( (lv_left_53_0= ruleFormula ) ) )
                    // InternalEtl.g:1393:4: () otherlv_47= 'by' ( (lv_interval_48_0= ruleInterval ) ) ( (lv_right_49_0= ruleFormula ) ) otherlv_50= 'and' otherlv_51= 'until' otherlv_52= 'then' ( (lv_left_53_0= ruleFormula ) )
                    {
                    // InternalEtl.g:1393:4: ()
                    // InternalEtl.g:1394:5: 
                    {

                    					current = forceCreateModelElement(
                    						grammarAccess.getFormulaAccess().getUntilFormulaAction_11_0(),
                    						current);
                    				

                    }

                    otherlv_47=(Token)match(input,42,FOLLOW_26); 

                    				newLeafNode(otherlv_47, grammarAccess.getFormulaAccess().getByKeyword_11_1());
                    			
                    // InternalEtl.g:1404:4: ( (lv_interval_48_0= ruleInterval ) )
                    // InternalEtl.g:1405:5: (lv_interval_48_0= ruleInterval )
                    {
                    // InternalEtl.g:1405:5: (lv_interval_48_0= ruleInterval )
                    // InternalEtl.g:1406:6: lv_interval_48_0= ruleInterval
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getIntervalIntervalParserRuleCall_11_2_0());
                    					
                    pushFollow(FOLLOW_9);
                    lv_interval_48_0=ruleInterval();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"interval",
                    							lv_interval_48_0,
                    							"org.eclipse.trace4cps.tl.Etl.Interval");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    // InternalEtl.g:1423:4: ( (lv_right_49_0= ruleFormula ) )
                    // InternalEtl.g:1424:5: (lv_right_49_0= ruleFormula )
                    {
                    // InternalEtl.g:1424:5: (lv_right_49_0= ruleFormula )
                    // InternalEtl.g:1425:6: lv_right_49_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getRightFormulaParserRuleCall_11_3_0());
                    					
                    pushFollow(FOLLOW_30);
                    lv_right_49_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"right",
                    							lv_right_49_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }

                    otherlv_50=(Token)match(input,43,FOLLOW_31); 

                    				newLeafNode(otherlv_50, grammarAccess.getFormulaAccess().getAndKeyword_11_4());
                    			
                    otherlv_51=(Token)match(input,38,FOLLOW_25); 

                    				newLeafNode(otherlv_51, grammarAccess.getFormulaAccess().getUntilKeyword_11_5());
                    			
                    otherlv_52=(Token)match(input,33,FOLLOW_9); 

                    				newLeafNode(otherlv_52, grammarAccess.getFormulaAccess().getThenKeyword_11_6());
                    			
                    // InternalEtl.g:1454:4: ( (lv_left_53_0= ruleFormula ) )
                    // InternalEtl.g:1455:5: (lv_left_53_0= ruleFormula )
                    {
                    // InternalEtl.g:1455:5: (lv_left_53_0= ruleFormula )
                    // InternalEtl.g:1456:6: lv_left_53_0= ruleFormula
                    {

                    						newCompositeNode(grammarAccess.getFormulaAccess().getLeftFormulaParserRuleCall_11_7_0());
                    					
                    pushFollow(FOLLOW_2);
                    lv_left_53_0=ruleFormula();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getFormulaRule());
                    						}
                    						set(
                    							current,
                    							"left",
                    							lv_left_53_0,
                    							"org.eclipse.trace4cps.tl.Etl.Formula");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFormula"


    // $ANTLR start "entryRuleStlAp"
    // InternalEtl.g:1478:1: entryRuleStlAp returns [EObject current=null] : iv_ruleStlAp= ruleStlAp EOF ;
    public final EObject entryRuleStlAp() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleStlAp = null;


        try {
            // InternalEtl.g:1478:46: (iv_ruleStlAp= ruleStlAp EOF )
            // InternalEtl.g:1479:2: iv_ruleStlAp= ruleStlAp EOF
            {
             newCompositeNode(grammarAccess.getStlApRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleStlAp=ruleStlAp();

            state._fsp--;

             current =iv_ruleStlAp; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleStlAp"


    // $ANTLR start "ruleStlAp"
    // InternalEtl.g:1485:1: ruleStlAp returns [EObject current=null] : ( ( ( (otherlv_0= RULE_ID ) ) | ( () otherlv_2= 'd' ( (otherlv_3= RULE_ID ) ) otherlv_4= '/' otherlv_5= 'dt' ) ) ( (lv_compOp_6_0= ruleCompOp ) ) ( (lv_val_7_0= RULE_DOUBLE_T ) ) ) ;
    public final EObject ruleStlAp() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token lv_val_7_0=null;
        Enumerator lv_compOp_6_0 = null;



        	enterRule();

        try {
            // InternalEtl.g:1491:2: ( ( ( ( (otherlv_0= RULE_ID ) ) | ( () otherlv_2= 'd' ( (otherlv_3= RULE_ID ) ) otherlv_4= '/' otherlv_5= 'dt' ) ) ( (lv_compOp_6_0= ruleCompOp ) ) ( (lv_val_7_0= RULE_DOUBLE_T ) ) ) )
            // InternalEtl.g:1492:2: ( ( ( (otherlv_0= RULE_ID ) ) | ( () otherlv_2= 'd' ( (otherlv_3= RULE_ID ) ) otherlv_4= '/' otherlv_5= 'dt' ) ) ( (lv_compOp_6_0= ruleCompOp ) ) ( (lv_val_7_0= RULE_DOUBLE_T ) ) )
            {
            // InternalEtl.g:1492:2: ( ( ( (otherlv_0= RULE_ID ) ) | ( () otherlv_2= 'd' ( (otherlv_3= RULE_ID ) ) otherlv_4= '/' otherlv_5= 'dt' ) ) ( (lv_compOp_6_0= ruleCompOp ) ) ( (lv_val_7_0= RULE_DOUBLE_T ) ) )
            // InternalEtl.g:1493:3: ( ( (otherlv_0= RULE_ID ) ) | ( () otherlv_2= 'd' ( (otherlv_3= RULE_ID ) ) otherlv_4= '/' otherlv_5= 'dt' ) ) ( (lv_compOp_6_0= ruleCompOp ) ) ( (lv_val_7_0= RULE_DOUBLE_T ) )
            {
            // InternalEtl.g:1493:3: ( ( (otherlv_0= RULE_ID ) ) | ( () otherlv_2= 'd' ( (otherlv_3= RULE_ID ) ) otherlv_4= '/' otherlv_5= 'dt' ) )
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==RULE_ID) ) {
                alt17=1;
            }
            else if ( (LA17_0==44) ) {
                alt17=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 17, 0, input);

                throw nvae;
            }
            switch (alt17) {
                case 1 :
                    // InternalEtl.g:1494:4: ( (otherlv_0= RULE_ID ) )
                    {
                    // InternalEtl.g:1494:4: ( (otherlv_0= RULE_ID ) )
                    // InternalEtl.g:1495:5: (otherlv_0= RULE_ID )
                    {
                    // InternalEtl.g:1495:5: (otherlv_0= RULE_ID )
                    // InternalEtl.g:1496:6: otherlv_0= RULE_ID
                    {

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getStlApRule());
                    						}
                    					
                    otherlv_0=(Token)match(input,RULE_ID,FOLLOW_32); 

                    						newLeafNode(otherlv_0, grammarAccess.getStlApAccess().getRefSignalDefCrossReference_0_0_0());
                    					

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:1508:4: ( () otherlv_2= 'd' ( (otherlv_3= RULE_ID ) ) otherlv_4= '/' otherlv_5= 'dt' )
                    {
                    // InternalEtl.g:1508:4: ( () otherlv_2= 'd' ( (otherlv_3= RULE_ID ) ) otherlv_4= '/' otherlv_5= 'dt' )
                    // InternalEtl.g:1509:5: () otherlv_2= 'd' ( (otherlv_3= RULE_ID ) ) otherlv_4= '/' otherlv_5= 'dt'
                    {
                    // InternalEtl.g:1509:5: ()
                    // InternalEtl.g:1510:6: 
                    {

                    						current = forceCreateModelElement(
                    							grammarAccess.getStlApAccess().getStlApDerivAction_0_1_0(),
                    							current);
                    					

                    }

                    otherlv_2=(Token)match(input,44,FOLLOW_4); 

                    					newLeafNode(otherlv_2, grammarAccess.getStlApAccess().getDKeyword_0_1_1());
                    				
                    // InternalEtl.g:1520:5: ( (otherlv_3= RULE_ID ) )
                    // InternalEtl.g:1521:6: (otherlv_3= RULE_ID )
                    {
                    // InternalEtl.g:1521:6: (otherlv_3= RULE_ID )
                    // InternalEtl.g:1522:7: otherlv_3= RULE_ID
                    {

                    							if (current==null) {
                    								current = createModelElement(grammarAccess.getStlApRule());
                    							}
                    						
                    otherlv_3=(Token)match(input,RULE_ID,FOLLOW_33); 

                    							newLeafNode(otherlv_3, grammarAccess.getStlApAccess().getRefSignalDefCrossReference_0_1_2_0());
                    						

                    }


                    }

                    otherlv_4=(Token)match(input,45,FOLLOW_34); 

                    					newLeafNode(otherlv_4, grammarAccess.getStlApAccess().getSolidusKeyword_0_1_3());
                    				
                    otherlv_5=(Token)match(input,46,FOLLOW_32); 

                    					newLeafNode(otherlv_5, grammarAccess.getStlApAccess().getDtKeyword_0_1_4());
                    				

                    }


                    }
                    break;

            }

            // InternalEtl.g:1543:3: ( (lv_compOp_6_0= ruleCompOp ) )
            // InternalEtl.g:1544:4: (lv_compOp_6_0= ruleCompOp )
            {
            // InternalEtl.g:1544:4: (lv_compOp_6_0= ruleCompOp )
            // InternalEtl.g:1545:5: lv_compOp_6_0= ruleCompOp
            {

            					newCompositeNode(grammarAccess.getStlApAccess().getCompOpCompOpEnumRuleCall_1_0());
            				
            pushFollow(FOLLOW_21);
            lv_compOp_6_0=ruleCompOp();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getStlApRule());
            					}
            					set(
            						current,
            						"compOp",
            						lv_compOp_6_0,
            						"org.eclipse.trace4cps.tl.Etl.CompOp");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalEtl.g:1562:3: ( (lv_val_7_0= RULE_DOUBLE_T ) )
            // InternalEtl.g:1563:4: (lv_val_7_0= RULE_DOUBLE_T )
            {
            // InternalEtl.g:1563:4: (lv_val_7_0= RULE_DOUBLE_T )
            // InternalEtl.g:1564:5: lv_val_7_0= RULE_DOUBLE_T
            {
            lv_val_7_0=(Token)match(input,RULE_DOUBLE_T,FOLLOW_2); 

            					newLeafNode(lv_val_7_0, grammarAccess.getStlApAccess().getValDOUBLE_TTerminalRuleCall_2_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getStlApRule());
            					}
            					setWithLastConsumed(
            						current,
            						"val",
            						lv_val_7_0,
            						"org.eclipse.trace4cps.tl.Etl.DOUBLE_T");
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleStlAp"


    // $ANTLR start "entryRuleMtlAp"
    // InternalEtl.g:1584:1: entryRuleMtlAp returns [EObject current=null] : iv_ruleMtlAp= ruleMtlAp EOF ;
    public final EObject entryRuleMtlAp() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMtlAp = null;


        try {
            // InternalEtl.g:1584:46: (iv_ruleMtlAp= ruleMtlAp EOF )
            // InternalEtl.g:1585:2: iv_ruleMtlAp= ruleMtlAp EOF
            {
             newCompositeNode(grammarAccess.getMtlApRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleMtlAp=ruleMtlAp();

            state._fsp--;

             current =iv_ruleMtlAp; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMtlAp"


    // $ANTLR start "ruleMtlAp"
    // InternalEtl.g:1591:1: ruleMtlAp returns [EObject current=null] : ( ( ( () otherlv_1= 'start' ) | ( () otherlv_3= 'end' ) )? ( (lv_filter_4_0= ruleAttributeFilter ) ) ) ;
    public final EObject ruleMtlAp() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        EObject lv_filter_4_0 = null;



        	enterRule();

        try {
            // InternalEtl.g:1597:2: ( ( ( ( () otherlv_1= 'start' ) | ( () otherlv_3= 'end' ) )? ( (lv_filter_4_0= ruleAttributeFilter ) ) ) )
            // InternalEtl.g:1598:2: ( ( ( () otherlv_1= 'start' ) | ( () otherlv_3= 'end' ) )? ( (lv_filter_4_0= ruleAttributeFilter ) ) )
            {
            // InternalEtl.g:1598:2: ( ( ( () otherlv_1= 'start' ) | ( () otherlv_3= 'end' ) )? ( (lv_filter_4_0= ruleAttributeFilter ) ) )
            // InternalEtl.g:1599:3: ( ( () otherlv_1= 'start' ) | ( () otherlv_3= 'end' ) )? ( (lv_filter_4_0= ruleAttributeFilter ) )
            {
            // InternalEtl.g:1599:3: ( ( () otherlv_1= 'start' ) | ( () otherlv_3= 'end' ) )?
            int alt18=3;
            int LA18_0 = input.LA(1);

            if ( (LA18_0==47) ) {
                alt18=1;
            }
            else if ( (LA18_0==48) ) {
                alt18=2;
            }
            switch (alt18) {
                case 1 :
                    // InternalEtl.g:1600:4: ( () otherlv_1= 'start' )
                    {
                    // InternalEtl.g:1600:4: ( () otherlv_1= 'start' )
                    // InternalEtl.g:1601:5: () otherlv_1= 'start'
                    {
                    // InternalEtl.g:1601:5: ()
                    // InternalEtl.g:1602:6: 
                    {

                    						current = forceCreateModelElement(
                    							grammarAccess.getMtlApAccess().getMtlApStartAction_0_0_0(),
                    							current);
                    					

                    }

                    otherlv_1=(Token)match(input,47,FOLLOW_20); 

                    					newLeafNode(otherlv_1, grammarAccess.getMtlApAccess().getStartKeyword_0_0_1());
                    				

                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:1614:4: ( () otherlv_3= 'end' )
                    {
                    // InternalEtl.g:1614:4: ( () otherlv_3= 'end' )
                    // InternalEtl.g:1615:5: () otherlv_3= 'end'
                    {
                    // InternalEtl.g:1615:5: ()
                    // InternalEtl.g:1616:6: 
                    {

                    						current = forceCreateModelElement(
                    							grammarAccess.getMtlApAccess().getMtlApEndAction_0_1_0(),
                    							current);
                    					

                    }

                    otherlv_3=(Token)match(input,48,FOLLOW_20); 

                    					newLeafNode(otherlv_3, grammarAccess.getMtlApAccess().getEndKeyword_0_1_1());
                    				

                    }


                    }
                    break;

            }

            // InternalEtl.g:1628:3: ( (lv_filter_4_0= ruleAttributeFilter ) )
            // InternalEtl.g:1629:4: (lv_filter_4_0= ruleAttributeFilter )
            {
            // InternalEtl.g:1629:4: (lv_filter_4_0= ruleAttributeFilter )
            // InternalEtl.g:1630:5: lv_filter_4_0= ruleAttributeFilter
            {

            					newCompositeNode(grammarAccess.getMtlApAccess().getFilterAttributeFilterParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_2);
            lv_filter_4_0=ruleAttributeFilter();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getMtlApRule());
            					}
            					set(
            						current,
            						"filter",
            						lv_filter_4_0,
            						"org.eclipse.trace4cps.tl.Etl.AttributeFilter");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMtlAp"


    // $ANTLR start "entryRuleAttributeFilter"
    // InternalEtl.g:1651:1: entryRuleAttributeFilter returns [EObject current=null] : iv_ruleAttributeFilter= ruleAttributeFilter EOF ;
    public final EObject entryRuleAttributeFilter() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleAttributeFilter = null;


        try {
            // InternalEtl.g:1651:56: (iv_ruleAttributeFilter= ruleAttributeFilter EOF )
            // InternalEtl.g:1652:2: iv_ruleAttributeFilter= ruleAttributeFilter EOF
            {
             newCompositeNode(grammarAccess.getAttributeFilterRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleAttributeFilter=ruleAttributeFilter();

            state._fsp--;

             current =iv_ruleAttributeFilter; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleAttributeFilter"


    // $ANTLR start "ruleAttributeFilter"
    // InternalEtl.g:1658:1: ruleAttributeFilter returns [EObject current=null] : (otherlv_0= '{' ( (lv_keyVals_1_0= ruleKeyVal ) ) (otherlv_2= ',' ( (lv_keyVals_3_0= ruleKeyVal ) ) )* otherlv_4= '}' ) ;
    public final EObject ruleAttributeFilter() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        EObject lv_keyVals_1_0 = null;

        EObject lv_keyVals_3_0 = null;



        	enterRule();

        try {
            // InternalEtl.g:1664:2: ( (otherlv_0= '{' ( (lv_keyVals_1_0= ruleKeyVal ) ) (otherlv_2= ',' ( (lv_keyVals_3_0= ruleKeyVal ) ) )* otherlv_4= '}' ) )
            // InternalEtl.g:1665:2: (otherlv_0= '{' ( (lv_keyVals_1_0= ruleKeyVal ) ) (otherlv_2= ',' ( (lv_keyVals_3_0= ruleKeyVal ) ) )* otherlv_4= '}' )
            {
            // InternalEtl.g:1665:2: (otherlv_0= '{' ( (lv_keyVals_1_0= ruleKeyVal ) ) (otherlv_2= ',' ( (lv_keyVals_3_0= ruleKeyVal ) ) )* otherlv_4= '}' )
            // InternalEtl.g:1666:3: otherlv_0= '{' ( (lv_keyVals_1_0= ruleKeyVal ) ) (otherlv_2= ',' ( (lv_keyVals_3_0= ruleKeyVal ) ) )* otherlv_4= '}'
            {
            otherlv_0=(Token)match(input,49,FOLLOW_35); 

            			newLeafNode(otherlv_0, grammarAccess.getAttributeFilterAccess().getLeftCurlyBracketKeyword_0());
            		
            // InternalEtl.g:1670:3: ( (lv_keyVals_1_0= ruleKeyVal ) )
            // InternalEtl.g:1671:4: (lv_keyVals_1_0= ruleKeyVal )
            {
            // InternalEtl.g:1671:4: (lv_keyVals_1_0= ruleKeyVal )
            // InternalEtl.g:1672:5: lv_keyVals_1_0= ruleKeyVal
            {

            					newCompositeNode(grammarAccess.getAttributeFilterAccess().getKeyValsKeyValParserRuleCall_1_0());
            				
            pushFollow(FOLLOW_36);
            lv_keyVals_1_0=ruleKeyVal();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getAttributeFilterRule());
            					}
            					add(
            						current,
            						"keyVals",
            						lv_keyVals_1_0,
            						"org.eclipse.trace4cps.tl.Etl.KeyVal");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            // InternalEtl.g:1689:3: (otherlv_2= ',' ( (lv_keyVals_3_0= ruleKeyVal ) ) )*
            loop19:
            do {
                int alt19=2;
                int LA19_0 = input.LA(1);

                if ( (LA19_0==50) ) {
                    alt19=1;
                }


                switch (alt19) {
            	case 1 :
            	    // InternalEtl.g:1690:4: otherlv_2= ',' ( (lv_keyVals_3_0= ruleKeyVal ) )
            	    {
            	    otherlv_2=(Token)match(input,50,FOLLOW_35); 

            	    				newLeafNode(otherlv_2, grammarAccess.getAttributeFilterAccess().getCommaKeyword_2_0());
            	    			
            	    // InternalEtl.g:1694:4: ( (lv_keyVals_3_0= ruleKeyVal ) )
            	    // InternalEtl.g:1695:5: (lv_keyVals_3_0= ruleKeyVal )
            	    {
            	    // InternalEtl.g:1695:5: (lv_keyVals_3_0= ruleKeyVal )
            	    // InternalEtl.g:1696:6: lv_keyVals_3_0= ruleKeyVal
            	    {

            	    						newCompositeNode(grammarAccess.getAttributeFilterAccess().getKeyValsKeyValParserRuleCall_2_1_0());
            	    					
            	    pushFollow(FOLLOW_36);
            	    lv_keyVals_3_0=ruleKeyVal();

            	    state._fsp--;


            	    						if (current==null) {
            	    							current = createModelElementForParent(grammarAccess.getAttributeFilterRule());
            	    						}
            	    						add(
            	    							current,
            	    							"keyVals",
            	    							lv_keyVals_3_0,
            	    							"org.eclipse.trace4cps.tl.Etl.KeyVal");
            	    						afterParserOrEnumRuleCall();
            	    					

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop19;
                }
            } while (true);

            otherlv_4=(Token)match(input,51,FOLLOW_2); 

            			newLeafNode(otherlv_4, grammarAccess.getAttributeFilterAccess().getRightCurlyBracketKeyword_3());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAttributeFilter"


    // $ANTLR start "entryRuleKeyVal"
    // InternalEtl.g:1722:1: entryRuleKeyVal returns [EObject current=null] : iv_ruleKeyVal= ruleKeyVal EOF ;
    public final EObject entryRuleKeyVal() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleKeyVal = null;


        try {
            // InternalEtl.g:1722:47: (iv_ruleKeyVal= ruleKeyVal EOF )
            // InternalEtl.g:1723:2: iv_ruleKeyVal= ruleKeyVal EOF
            {
             newCompositeNode(grammarAccess.getKeyValRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleKeyVal=ruleKeyVal();

            state._fsp--;

             current =iv_ruleKeyVal; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleKeyVal"


    // $ANTLR start "ruleKeyVal"
    // InternalEtl.g:1729:1: ruleKeyVal returns [EObject current=null] : ( ( (lv_att_0_0= ruleIdString ) ) otherlv_1= '=' ( (lv_val_2_0= ruleIdString ) ) ) ;
    public final EObject ruleKeyVal() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        EObject lv_att_0_0 = null;

        EObject lv_val_2_0 = null;



        	enterRule();

        try {
            // InternalEtl.g:1735:2: ( ( ( (lv_att_0_0= ruleIdString ) ) otherlv_1= '=' ( (lv_val_2_0= ruleIdString ) ) ) )
            // InternalEtl.g:1736:2: ( ( (lv_att_0_0= ruleIdString ) ) otherlv_1= '=' ( (lv_val_2_0= ruleIdString ) ) )
            {
            // InternalEtl.g:1736:2: ( ( (lv_att_0_0= ruleIdString ) ) otherlv_1= '=' ( (lv_val_2_0= ruleIdString ) ) )
            // InternalEtl.g:1737:3: ( (lv_att_0_0= ruleIdString ) ) otherlv_1= '=' ( (lv_val_2_0= ruleIdString ) )
            {
            // InternalEtl.g:1737:3: ( (lv_att_0_0= ruleIdString ) )
            // InternalEtl.g:1738:4: (lv_att_0_0= ruleIdString )
            {
            // InternalEtl.g:1738:4: (lv_att_0_0= ruleIdString )
            // InternalEtl.g:1739:5: lv_att_0_0= ruleIdString
            {

            					newCompositeNode(grammarAccess.getKeyValAccess().getAttIdStringParserRuleCall_0_0());
            				
            pushFollow(FOLLOW_37);
            lv_att_0_0=ruleIdString();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getKeyValRule());
            					}
            					set(
            						current,
            						"att",
            						lv_att_0_0,
            						"org.eclipse.trace4cps.tl.Etl.IdString");
            					afterParserOrEnumRuleCall();
            				

            }


            }

            otherlv_1=(Token)match(input,52,FOLLOW_35); 

            			newLeafNode(otherlv_1, grammarAccess.getKeyValAccess().getEqualsSignKeyword_1());
            		
            // InternalEtl.g:1760:3: ( (lv_val_2_0= ruleIdString ) )
            // InternalEtl.g:1761:4: (lv_val_2_0= ruleIdString )
            {
            // InternalEtl.g:1761:4: (lv_val_2_0= ruleIdString )
            // InternalEtl.g:1762:5: lv_val_2_0= ruleIdString
            {

            					newCompositeNode(grammarAccess.getKeyValAccess().getValIdStringParserRuleCall_2_0());
            				
            pushFollow(FOLLOW_2);
            lv_val_2_0=ruleIdString();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getKeyValRule());
            					}
            					set(
            						current,
            						"val",
            						lv_val_2_0,
            						"org.eclipse.trace4cps.tl.Etl.IdString");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleKeyVal"


    // $ANTLR start "entryRuleIdString"
    // InternalEtl.g:1783:1: entryRuleIdString returns [EObject current=null] : iv_ruleIdString= ruleIdString EOF ;
    public final EObject entryRuleIdString() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleIdString = null;


        try {
            // InternalEtl.g:1783:49: (iv_ruleIdString= ruleIdString EOF )
            // InternalEtl.g:1784:2: iv_ruleIdString= ruleIdString EOF
            {
             newCompositeNode(grammarAccess.getIdStringRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleIdString=ruleIdString();

            state._fsp--;

             current =iv_ruleIdString; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleIdString"


    // $ANTLR start "ruleIdString"
    // InternalEtl.g:1790:1: ruleIdString returns [EObject current=null] : ( ( (lv_left_0_0= RULE_STRING ) ) | ( (lv_id_1_0= RULE_ID ) ) | ( ( (lv_left_2_0= RULE_STRING ) ) otherlv_3= '+' ( (lv_id_4_0= RULE_ID ) ) ) | ( ( (lv_id_5_0= RULE_ID ) ) otherlv_6= '+' ( (lv_right_7_0= RULE_STRING ) ) ) | ( ( (lv_left_8_0= RULE_STRING ) ) otherlv_9= '+' ( (lv_id_10_0= RULE_ID ) ) otherlv_11= '+' ( (lv_right_12_0= RULE_STRING ) ) ) ) ;
    public final EObject ruleIdString() throws RecognitionException {
        EObject current = null;

        Token lv_left_0_0=null;
        Token lv_id_1_0=null;
        Token lv_left_2_0=null;
        Token otherlv_3=null;
        Token lv_id_4_0=null;
        Token lv_id_5_0=null;
        Token otherlv_6=null;
        Token lv_right_7_0=null;
        Token lv_left_8_0=null;
        Token otherlv_9=null;
        Token lv_id_10_0=null;
        Token otherlv_11=null;
        Token lv_right_12_0=null;


        	enterRule();

        try {
            // InternalEtl.g:1796:2: ( ( ( (lv_left_0_0= RULE_STRING ) ) | ( (lv_id_1_0= RULE_ID ) ) | ( ( (lv_left_2_0= RULE_STRING ) ) otherlv_3= '+' ( (lv_id_4_0= RULE_ID ) ) ) | ( ( (lv_id_5_0= RULE_ID ) ) otherlv_6= '+' ( (lv_right_7_0= RULE_STRING ) ) ) | ( ( (lv_left_8_0= RULE_STRING ) ) otherlv_9= '+' ( (lv_id_10_0= RULE_ID ) ) otherlv_11= '+' ( (lv_right_12_0= RULE_STRING ) ) ) ) )
            // InternalEtl.g:1797:2: ( ( (lv_left_0_0= RULE_STRING ) ) | ( (lv_id_1_0= RULE_ID ) ) | ( ( (lv_left_2_0= RULE_STRING ) ) otherlv_3= '+' ( (lv_id_4_0= RULE_ID ) ) ) | ( ( (lv_id_5_0= RULE_ID ) ) otherlv_6= '+' ( (lv_right_7_0= RULE_STRING ) ) ) | ( ( (lv_left_8_0= RULE_STRING ) ) otherlv_9= '+' ( (lv_id_10_0= RULE_ID ) ) otherlv_11= '+' ( (lv_right_12_0= RULE_STRING ) ) ) )
            {
            // InternalEtl.g:1797:2: ( ( (lv_left_0_0= RULE_STRING ) ) | ( (lv_id_1_0= RULE_ID ) ) | ( ( (lv_left_2_0= RULE_STRING ) ) otherlv_3= '+' ( (lv_id_4_0= RULE_ID ) ) ) | ( ( (lv_id_5_0= RULE_ID ) ) otherlv_6= '+' ( (lv_right_7_0= RULE_STRING ) ) ) | ( ( (lv_left_8_0= RULE_STRING ) ) otherlv_9= '+' ( (lv_id_10_0= RULE_ID ) ) otherlv_11= '+' ( (lv_right_12_0= RULE_STRING ) ) ) )
            int alt20=5;
            alt20 = dfa20.predict(input);
            switch (alt20) {
                case 1 :
                    // InternalEtl.g:1798:3: ( (lv_left_0_0= RULE_STRING ) )
                    {
                    // InternalEtl.g:1798:3: ( (lv_left_0_0= RULE_STRING ) )
                    // InternalEtl.g:1799:4: (lv_left_0_0= RULE_STRING )
                    {
                    // InternalEtl.g:1799:4: (lv_left_0_0= RULE_STRING )
                    // InternalEtl.g:1800:5: lv_left_0_0= RULE_STRING
                    {
                    lv_left_0_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

                    					newLeafNode(lv_left_0_0, grammarAccess.getIdStringAccess().getLeftSTRINGTerminalRuleCall_0_0());
                    				

                    					if (current==null) {
                    						current = createModelElement(grammarAccess.getIdStringRule());
                    					}
                    					setWithLastConsumed(
                    						current,
                    						"left",
                    						lv_left_0_0,
                    						"org.eclipse.xtext.common.Terminals.STRING");
                    				

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:1817:3: ( (lv_id_1_0= RULE_ID ) )
                    {
                    // InternalEtl.g:1817:3: ( (lv_id_1_0= RULE_ID ) )
                    // InternalEtl.g:1818:4: (lv_id_1_0= RULE_ID )
                    {
                    // InternalEtl.g:1818:4: (lv_id_1_0= RULE_ID )
                    // InternalEtl.g:1819:5: lv_id_1_0= RULE_ID
                    {
                    lv_id_1_0=(Token)match(input,RULE_ID,FOLLOW_2); 

                    					newLeafNode(lv_id_1_0, grammarAccess.getIdStringAccess().getIdIDTerminalRuleCall_1_0());
                    				

                    					if (current==null) {
                    						current = createModelElement(grammarAccess.getIdStringRule());
                    					}
                    					setWithLastConsumed(
                    						current,
                    						"id",
                    						lv_id_1_0,
                    						"org.eclipse.xtext.common.Terminals.ID");
                    				

                    }


                    }


                    }
                    break;
                case 3 :
                    // InternalEtl.g:1836:3: ( ( (lv_left_2_0= RULE_STRING ) ) otherlv_3= '+' ( (lv_id_4_0= RULE_ID ) ) )
                    {
                    // InternalEtl.g:1836:3: ( ( (lv_left_2_0= RULE_STRING ) ) otherlv_3= '+' ( (lv_id_4_0= RULE_ID ) ) )
                    // InternalEtl.g:1837:4: ( (lv_left_2_0= RULE_STRING ) ) otherlv_3= '+' ( (lv_id_4_0= RULE_ID ) )
                    {
                    // InternalEtl.g:1837:4: ( (lv_left_2_0= RULE_STRING ) )
                    // InternalEtl.g:1838:5: (lv_left_2_0= RULE_STRING )
                    {
                    // InternalEtl.g:1838:5: (lv_left_2_0= RULE_STRING )
                    // InternalEtl.g:1839:6: lv_left_2_0= RULE_STRING
                    {
                    lv_left_2_0=(Token)match(input,RULE_STRING,FOLLOW_38); 

                    						newLeafNode(lv_left_2_0, grammarAccess.getIdStringAccess().getLeftSTRINGTerminalRuleCall_2_0_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getIdStringRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"left",
                    							lv_left_2_0,
                    							"org.eclipse.xtext.common.Terminals.STRING");
                    					

                    }


                    }

                    otherlv_3=(Token)match(input,30,FOLLOW_4); 

                    				newLeafNode(otherlv_3, grammarAccess.getIdStringAccess().getPlusSignKeyword_2_1());
                    			
                    // InternalEtl.g:1859:4: ( (lv_id_4_0= RULE_ID ) )
                    // InternalEtl.g:1860:5: (lv_id_4_0= RULE_ID )
                    {
                    // InternalEtl.g:1860:5: (lv_id_4_0= RULE_ID )
                    // InternalEtl.g:1861:6: lv_id_4_0= RULE_ID
                    {
                    lv_id_4_0=(Token)match(input,RULE_ID,FOLLOW_2); 

                    						newLeafNode(lv_id_4_0, grammarAccess.getIdStringAccess().getIdIDTerminalRuleCall_2_2_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getIdStringRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"id",
                    							lv_id_4_0,
                    							"org.eclipse.xtext.common.Terminals.ID");
                    					

                    }


                    }


                    }


                    }
                    break;
                case 4 :
                    // InternalEtl.g:1879:3: ( ( (lv_id_5_0= RULE_ID ) ) otherlv_6= '+' ( (lv_right_7_0= RULE_STRING ) ) )
                    {
                    // InternalEtl.g:1879:3: ( ( (lv_id_5_0= RULE_ID ) ) otherlv_6= '+' ( (lv_right_7_0= RULE_STRING ) ) )
                    // InternalEtl.g:1880:4: ( (lv_id_5_0= RULE_ID ) ) otherlv_6= '+' ( (lv_right_7_0= RULE_STRING ) )
                    {
                    // InternalEtl.g:1880:4: ( (lv_id_5_0= RULE_ID ) )
                    // InternalEtl.g:1881:5: (lv_id_5_0= RULE_ID )
                    {
                    // InternalEtl.g:1881:5: (lv_id_5_0= RULE_ID )
                    // InternalEtl.g:1882:6: lv_id_5_0= RULE_ID
                    {
                    lv_id_5_0=(Token)match(input,RULE_ID,FOLLOW_38); 

                    						newLeafNode(lv_id_5_0, grammarAccess.getIdStringAccess().getIdIDTerminalRuleCall_3_0_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getIdStringRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"id",
                    							lv_id_5_0,
                    							"org.eclipse.xtext.common.Terminals.ID");
                    					

                    }


                    }

                    otherlv_6=(Token)match(input,30,FOLLOW_39); 

                    				newLeafNode(otherlv_6, grammarAccess.getIdStringAccess().getPlusSignKeyword_3_1());
                    			
                    // InternalEtl.g:1902:4: ( (lv_right_7_0= RULE_STRING ) )
                    // InternalEtl.g:1903:5: (lv_right_7_0= RULE_STRING )
                    {
                    // InternalEtl.g:1903:5: (lv_right_7_0= RULE_STRING )
                    // InternalEtl.g:1904:6: lv_right_7_0= RULE_STRING
                    {
                    lv_right_7_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

                    						newLeafNode(lv_right_7_0, grammarAccess.getIdStringAccess().getRightSTRINGTerminalRuleCall_3_2_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getIdStringRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"right",
                    							lv_right_7_0,
                    							"org.eclipse.xtext.common.Terminals.STRING");
                    					

                    }


                    }


                    }


                    }
                    break;
                case 5 :
                    // InternalEtl.g:1922:3: ( ( (lv_left_8_0= RULE_STRING ) ) otherlv_9= '+' ( (lv_id_10_0= RULE_ID ) ) otherlv_11= '+' ( (lv_right_12_0= RULE_STRING ) ) )
                    {
                    // InternalEtl.g:1922:3: ( ( (lv_left_8_0= RULE_STRING ) ) otherlv_9= '+' ( (lv_id_10_0= RULE_ID ) ) otherlv_11= '+' ( (lv_right_12_0= RULE_STRING ) ) )
                    // InternalEtl.g:1923:4: ( (lv_left_8_0= RULE_STRING ) ) otherlv_9= '+' ( (lv_id_10_0= RULE_ID ) ) otherlv_11= '+' ( (lv_right_12_0= RULE_STRING ) )
                    {
                    // InternalEtl.g:1923:4: ( (lv_left_8_0= RULE_STRING ) )
                    // InternalEtl.g:1924:5: (lv_left_8_0= RULE_STRING )
                    {
                    // InternalEtl.g:1924:5: (lv_left_8_0= RULE_STRING )
                    // InternalEtl.g:1925:6: lv_left_8_0= RULE_STRING
                    {
                    lv_left_8_0=(Token)match(input,RULE_STRING,FOLLOW_38); 

                    						newLeafNode(lv_left_8_0, grammarAccess.getIdStringAccess().getLeftSTRINGTerminalRuleCall_4_0_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getIdStringRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"left",
                    							lv_left_8_0,
                    							"org.eclipse.xtext.common.Terminals.STRING");
                    					

                    }


                    }

                    otherlv_9=(Token)match(input,30,FOLLOW_4); 

                    				newLeafNode(otherlv_9, grammarAccess.getIdStringAccess().getPlusSignKeyword_4_1());
                    			
                    // InternalEtl.g:1945:4: ( (lv_id_10_0= RULE_ID ) )
                    // InternalEtl.g:1946:5: (lv_id_10_0= RULE_ID )
                    {
                    // InternalEtl.g:1946:5: (lv_id_10_0= RULE_ID )
                    // InternalEtl.g:1947:6: lv_id_10_0= RULE_ID
                    {
                    lv_id_10_0=(Token)match(input,RULE_ID,FOLLOW_38); 

                    						newLeafNode(lv_id_10_0, grammarAccess.getIdStringAccess().getIdIDTerminalRuleCall_4_2_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getIdStringRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"id",
                    							lv_id_10_0,
                    							"org.eclipse.xtext.common.Terminals.ID");
                    					

                    }


                    }

                    otherlv_11=(Token)match(input,30,FOLLOW_39); 

                    				newLeafNode(otherlv_11, grammarAccess.getIdStringAccess().getPlusSignKeyword_4_3());
                    			
                    // InternalEtl.g:1967:4: ( (lv_right_12_0= RULE_STRING ) )
                    // InternalEtl.g:1968:5: (lv_right_12_0= RULE_STRING )
                    {
                    // InternalEtl.g:1968:5: (lv_right_12_0= RULE_STRING )
                    // InternalEtl.g:1969:6: lv_right_12_0= RULE_STRING
                    {
                    lv_right_12_0=(Token)match(input,RULE_STRING,FOLLOW_2); 

                    						newLeafNode(lv_right_12_0, grammarAccess.getIdStringAccess().getRightSTRINGTerminalRuleCall_4_4_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getIdStringRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"right",
                    							lv_right_12_0,
                    							"org.eclipse.xtext.common.Terminals.STRING");
                    					

                    }


                    }


                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleIdString"


    // $ANTLR start "entryRuleInterval"
    // InternalEtl.g:1990:1: entryRuleInterval returns [EObject current=null] : iv_ruleInterval= ruleInterval EOF ;
    public final EObject entryRuleInterval() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleInterval = null;


        try {
            // InternalEtl.g:1990:49: (iv_ruleInterval= ruleInterval EOF )
            // InternalEtl.g:1991:2: iv_ruleInterval= ruleInterval EOF
            {
             newCompositeNode(grammarAccess.getIntervalRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleInterval=ruleInterval();

            state._fsp--;

             current =iv_ruleInterval; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleInterval"


    // $ANTLR start "ruleInterval"
    // InternalEtl.g:1997:1: ruleInterval returns [EObject current=null] : ( ( ( (lv_iss_0_0= ruleIntervalSS ) ) | ( (lv_isn_1_0= ruleIntervalSN ) ) | ( (lv_ins_2_0= ruleIntervalNS ) ) | ( (lv_inn_3_0= ruleIntervalNN ) ) ) ( (lv_timeUnit_4_0= ruleTimeUnitEnum ) ) ) ;
    public final EObject ruleInterval() throws RecognitionException {
        EObject current = null;

        EObject lv_iss_0_0 = null;

        EObject lv_isn_1_0 = null;

        EObject lv_ins_2_0 = null;

        EObject lv_inn_3_0 = null;

        Enumerator lv_timeUnit_4_0 = null;



        	enterRule();

        try {
            // InternalEtl.g:2003:2: ( ( ( ( (lv_iss_0_0= ruleIntervalSS ) ) | ( (lv_isn_1_0= ruleIntervalSN ) ) | ( (lv_ins_2_0= ruleIntervalNS ) ) | ( (lv_inn_3_0= ruleIntervalNN ) ) ) ( (lv_timeUnit_4_0= ruleTimeUnitEnum ) ) ) )
            // InternalEtl.g:2004:2: ( ( ( (lv_iss_0_0= ruleIntervalSS ) ) | ( (lv_isn_1_0= ruleIntervalSN ) ) | ( (lv_ins_2_0= ruleIntervalNS ) ) | ( (lv_inn_3_0= ruleIntervalNN ) ) ) ( (lv_timeUnit_4_0= ruleTimeUnitEnum ) ) )
            {
            // InternalEtl.g:2004:2: ( ( ( (lv_iss_0_0= ruleIntervalSS ) ) | ( (lv_isn_1_0= ruleIntervalSN ) ) | ( (lv_ins_2_0= ruleIntervalNS ) ) | ( (lv_inn_3_0= ruleIntervalNN ) ) ) ( (lv_timeUnit_4_0= ruleTimeUnitEnum ) ) )
            // InternalEtl.g:2005:3: ( ( (lv_iss_0_0= ruleIntervalSS ) ) | ( (lv_isn_1_0= ruleIntervalSN ) ) | ( (lv_ins_2_0= ruleIntervalNS ) ) | ( (lv_inn_3_0= ruleIntervalNN ) ) ) ( (lv_timeUnit_4_0= ruleTimeUnitEnum ) )
            {
            // InternalEtl.g:2005:3: ( ( (lv_iss_0_0= ruleIntervalSS ) ) | ( (lv_isn_1_0= ruleIntervalSN ) ) | ( (lv_ins_2_0= ruleIntervalNS ) ) | ( (lv_inn_3_0= ruleIntervalNN ) ) )
            int alt21=4;
            alt21 = dfa21.predict(input);
            switch (alt21) {
                case 1 :
                    // InternalEtl.g:2006:4: ( (lv_iss_0_0= ruleIntervalSS ) )
                    {
                    // InternalEtl.g:2006:4: ( (lv_iss_0_0= ruleIntervalSS ) )
                    // InternalEtl.g:2007:5: (lv_iss_0_0= ruleIntervalSS )
                    {
                    // InternalEtl.g:2007:5: (lv_iss_0_0= ruleIntervalSS )
                    // InternalEtl.g:2008:6: lv_iss_0_0= ruleIntervalSS
                    {

                    						newCompositeNode(grammarAccess.getIntervalAccess().getIssIntervalSSParserRuleCall_0_0_0());
                    					
                    pushFollow(FOLLOW_17);
                    lv_iss_0_0=ruleIntervalSS();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getIntervalRule());
                    						}
                    						set(
                    							current,
                    							"iss",
                    							lv_iss_0_0,
                    							"org.eclipse.trace4cps.tl.Etl.IntervalSS");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:2026:4: ( (lv_isn_1_0= ruleIntervalSN ) )
                    {
                    // InternalEtl.g:2026:4: ( (lv_isn_1_0= ruleIntervalSN ) )
                    // InternalEtl.g:2027:5: (lv_isn_1_0= ruleIntervalSN )
                    {
                    // InternalEtl.g:2027:5: (lv_isn_1_0= ruleIntervalSN )
                    // InternalEtl.g:2028:6: lv_isn_1_0= ruleIntervalSN
                    {

                    						newCompositeNode(grammarAccess.getIntervalAccess().getIsnIntervalSNParserRuleCall_0_1_0());
                    					
                    pushFollow(FOLLOW_17);
                    lv_isn_1_0=ruleIntervalSN();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getIntervalRule());
                    						}
                    						set(
                    							current,
                    							"isn",
                    							lv_isn_1_0,
                    							"org.eclipse.trace4cps.tl.Etl.IntervalSN");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }
                    break;
                case 3 :
                    // InternalEtl.g:2046:4: ( (lv_ins_2_0= ruleIntervalNS ) )
                    {
                    // InternalEtl.g:2046:4: ( (lv_ins_2_0= ruleIntervalNS ) )
                    // InternalEtl.g:2047:5: (lv_ins_2_0= ruleIntervalNS )
                    {
                    // InternalEtl.g:2047:5: (lv_ins_2_0= ruleIntervalNS )
                    // InternalEtl.g:2048:6: lv_ins_2_0= ruleIntervalNS
                    {

                    						newCompositeNode(grammarAccess.getIntervalAccess().getInsIntervalNSParserRuleCall_0_2_0());
                    					
                    pushFollow(FOLLOW_17);
                    lv_ins_2_0=ruleIntervalNS();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getIntervalRule());
                    						}
                    						set(
                    							current,
                    							"ins",
                    							lv_ins_2_0,
                    							"org.eclipse.trace4cps.tl.Etl.IntervalNS");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }
                    break;
                case 4 :
                    // InternalEtl.g:2066:4: ( (lv_inn_3_0= ruleIntervalNN ) )
                    {
                    // InternalEtl.g:2066:4: ( (lv_inn_3_0= ruleIntervalNN ) )
                    // InternalEtl.g:2067:5: (lv_inn_3_0= ruleIntervalNN )
                    {
                    // InternalEtl.g:2067:5: (lv_inn_3_0= ruleIntervalNN )
                    // InternalEtl.g:2068:6: lv_inn_3_0= ruleIntervalNN
                    {

                    						newCompositeNode(grammarAccess.getIntervalAccess().getInnIntervalNNParserRuleCall_0_3_0());
                    					
                    pushFollow(FOLLOW_17);
                    lv_inn_3_0=ruleIntervalNN();

                    state._fsp--;


                    						if (current==null) {
                    							current = createModelElementForParent(grammarAccess.getIntervalRule());
                    						}
                    						set(
                    							current,
                    							"inn",
                    							lv_inn_3_0,
                    							"org.eclipse.trace4cps.tl.Etl.IntervalNN");
                    						afterParserOrEnumRuleCall();
                    					

                    }


                    }


                    }
                    break;

            }

            // InternalEtl.g:2086:3: ( (lv_timeUnit_4_0= ruleTimeUnitEnum ) )
            // InternalEtl.g:2087:4: (lv_timeUnit_4_0= ruleTimeUnitEnum )
            {
            // InternalEtl.g:2087:4: (lv_timeUnit_4_0= ruleTimeUnitEnum )
            // InternalEtl.g:2088:5: lv_timeUnit_4_0= ruleTimeUnitEnum
            {

            					newCompositeNode(grammarAccess.getIntervalAccess().getTimeUnitTimeUnitEnumEnumRuleCall_1_0());
            				
            pushFollow(FOLLOW_2);
            lv_timeUnit_4_0=ruleTimeUnitEnum();

            state._fsp--;


            					if (current==null) {
            						current = createModelElementForParent(grammarAccess.getIntervalRule());
            					}
            					set(
            						current,
            						"timeUnit",
            						lv_timeUnit_4_0,
            						"org.eclipse.trace4cps.tl.Etl.TimeUnitEnum");
            					afterParserOrEnumRuleCall();
            				

            }


            }


            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleInterval"


    // $ANTLR start "entryRuleIntervalSS"
    // InternalEtl.g:2109:1: entryRuleIntervalSS returns [EObject current=null] : iv_ruleIntervalSS= ruleIntervalSS EOF ;
    public final EObject entryRuleIntervalSS() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleIntervalSS = null;


        try {
            // InternalEtl.g:2109:51: (iv_ruleIntervalSS= ruleIntervalSS EOF )
            // InternalEtl.g:2110:2: iv_ruleIntervalSS= ruleIntervalSS EOF
            {
             newCompositeNode(grammarAccess.getIntervalSSRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleIntervalSS=ruleIntervalSS();

            state._fsp--;

             current =iv_ruleIntervalSS; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleIntervalSS"


    // $ANTLR start "ruleIntervalSS"
    // InternalEtl.g:2116:1: ruleIntervalSS returns [EObject current=null] : (otherlv_0= '(' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) ) otherlv_5= ')' ) ;
    public final EObject ruleIntervalSS() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_lb_1_0=null;
        Token otherlv_2=null;
        Token lv_ub_3_0=null;
        Token lv_infty_4_0=null;
        Token otherlv_5=null;


        	enterRule();

        try {
            // InternalEtl.g:2122:2: ( (otherlv_0= '(' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) ) otherlv_5= ')' ) )
            // InternalEtl.g:2123:2: (otherlv_0= '(' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) ) otherlv_5= ')' )
            {
            // InternalEtl.g:2123:2: (otherlv_0= '(' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) ) otherlv_5= ')' )
            // InternalEtl.g:2124:3: otherlv_0= '(' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) ) otherlv_5= ')'
            {
            otherlv_0=(Token)match(input,16,FOLLOW_21); 

            			newLeafNode(otherlv_0, grammarAccess.getIntervalSSAccess().getLeftParenthesisKeyword_0());
            		
            // InternalEtl.g:2128:3: ( (lv_lb_1_0= RULE_DOUBLE_T ) )
            // InternalEtl.g:2129:4: (lv_lb_1_0= RULE_DOUBLE_T )
            {
            // InternalEtl.g:2129:4: (lv_lb_1_0= RULE_DOUBLE_T )
            // InternalEtl.g:2130:5: lv_lb_1_0= RULE_DOUBLE_T
            {
            lv_lb_1_0=(Token)match(input,RULE_DOUBLE_T,FOLLOW_40); 

            					newLeafNode(lv_lb_1_0, grammarAccess.getIntervalSSAccess().getLbDOUBLE_TTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getIntervalSSRule());
            					}
            					setWithLastConsumed(
            						current,
            						"lb",
            						lv_lb_1_0,
            						"org.eclipse.trace4cps.tl.Etl.DOUBLE_T");
            				

            }


            }

            otherlv_2=(Token)match(input,50,FOLLOW_41); 

            			newLeafNode(otherlv_2, grammarAccess.getIntervalSSAccess().getCommaKeyword_2());
            		
            // InternalEtl.g:2150:3: ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) )
            int alt22=2;
            int LA22_0 = input.LA(1);

            if ( (LA22_0==RULE_DOUBLE_T) ) {
                alt22=1;
            }
            else if ( (LA22_0==53) ) {
                alt22=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 22, 0, input);

                throw nvae;
            }
            switch (alt22) {
                case 1 :
                    // InternalEtl.g:2151:4: ( (lv_ub_3_0= RULE_DOUBLE_T ) )
                    {
                    // InternalEtl.g:2151:4: ( (lv_ub_3_0= RULE_DOUBLE_T ) )
                    // InternalEtl.g:2152:5: (lv_ub_3_0= RULE_DOUBLE_T )
                    {
                    // InternalEtl.g:2152:5: (lv_ub_3_0= RULE_DOUBLE_T )
                    // InternalEtl.g:2153:6: lv_ub_3_0= RULE_DOUBLE_T
                    {
                    lv_ub_3_0=(Token)match(input,RULE_DOUBLE_T,FOLLOW_8); 

                    						newLeafNode(lv_ub_3_0, grammarAccess.getIntervalSSAccess().getUbDOUBLE_TTerminalRuleCall_3_0_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getIntervalSSRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"ub",
                    							lv_ub_3_0,
                    							"org.eclipse.trace4cps.tl.Etl.DOUBLE_T");
                    					

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:2170:4: ( (lv_infty_4_0= 'Infty' ) )
                    {
                    // InternalEtl.g:2170:4: ( (lv_infty_4_0= 'Infty' ) )
                    // InternalEtl.g:2171:5: (lv_infty_4_0= 'Infty' )
                    {
                    // InternalEtl.g:2171:5: (lv_infty_4_0= 'Infty' )
                    // InternalEtl.g:2172:6: lv_infty_4_0= 'Infty'
                    {
                    lv_infty_4_0=(Token)match(input,53,FOLLOW_8); 

                    						newLeafNode(lv_infty_4_0, grammarAccess.getIntervalSSAccess().getInftyInftyKeyword_3_1_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getIntervalSSRule());
                    						}
                    						setWithLastConsumed(current, "infty", lv_infty_4_0, "Infty");
                    					

                    }


                    }


                    }
                    break;

            }

            otherlv_5=(Token)match(input,17,FOLLOW_2); 

            			newLeafNode(otherlv_5, grammarAccess.getIntervalSSAccess().getRightParenthesisKeyword_4());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleIntervalSS"


    // $ANTLR start "entryRuleIntervalSN"
    // InternalEtl.g:2193:1: entryRuleIntervalSN returns [EObject current=null] : iv_ruleIntervalSN= ruleIntervalSN EOF ;
    public final EObject entryRuleIntervalSN() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleIntervalSN = null;


        try {
            // InternalEtl.g:2193:51: (iv_ruleIntervalSN= ruleIntervalSN EOF )
            // InternalEtl.g:2194:2: iv_ruleIntervalSN= ruleIntervalSN EOF
            {
             newCompositeNode(grammarAccess.getIntervalSNRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleIntervalSN=ruleIntervalSN();

            state._fsp--;

             current =iv_ruleIntervalSN; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleIntervalSN"


    // $ANTLR start "ruleIntervalSN"
    // InternalEtl.g:2200:1: ruleIntervalSN returns [EObject current=null] : (otherlv_0= '(' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( (lv_ub_3_0= RULE_DOUBLE_T ) ) otherlv_4= ']' ) ;
    public final EObject ruleIntervalSN() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_lb_1_0=null;
        Token otherlv_2=null;
        Token lv_ub_3_0=null;
        Token otherlv_4=null;


        	enterRule();

        try {
            // InternalEtl.g:2206:2: ( (otherlv_0= '(' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( (lv_ub_3_0= RULE_DOUBLE_T ) ) otherlv_4= ']' ) )
            // InternalEtl.g:2207:2: (otherlv_0= '(' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( (lv_ub_3_0= RULE_DOUBLE_T ) ) otherlv_4= ']' )
            {
            // InternalEtl.g:2207:2: (otherlv_0= '(' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( (lv_ub_3_0= RULE_DOUBLE_T ) ) otherlv_4= ']' )
            // InternalEtl.g:2208:3: otherlv_0= '(' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( (lv_ub_3_0= RULE_DOUBLE_T ) ) otherlv_4= ']'
            {
            otherlv_0=(Token)match(input,16,FOLLOW_21); 

            			newLeafNode(otherlv_0, grammarAccess.getIntervalSNAccess().getLeftParenthesisKeyword_0());
            		
            // InternalEtl.g:2212:3: ( (lv_lb_1_0= RULE_DOUBLE_T ) )
            // InternalEtl.g:2213:4: (lv_lb_1_0= RULE_DOUBLE_T )
            {
            // InternalEtl.g:2213:4: (lv_lb_1_0= RULE_DOUBLE_T )
            // InternalEtl.g:2214:5: lv_lb_1_0= RULE_DOUBLE_T
            {
            lv_lb_1_0=(Token)match(input,RULE_DOUBLE_T,FOLLOW_40); 

            					newLeafNode(lv_lb_1_0, grammarAccess.getIntervalSNAccess().getLbDOUBLE_TTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getIntervalSNRule());
            					}
            					setWithLastConsumed(
            						current,
            						"lb",
            						lv_lb_1_0,
            						"org.eclipse.trace4cps.tl.Etl.DOUBLE_T");
            				

            }


            }

            otherlv_2=(Token)match(input,50,FOLLOW_21); 

            			newLeafNode(otherlv_2, grammarAccess.getIntervalSNAccess().getCommaKeyword_2());
            		
            // InternalEtl.g:2234:3: ( (lv_ub_3_0= RULE_DOUBLE_T ) )
            // InternalEtl.g:2235:4: (lv_ub_3_0= RULE_DOUBLE_T )
            {
            // InternalEtl.g:2235:4: (lv_ub_3_0= RULE_DOUBLE_T )
            // InternalEtl.g:2236:5: lv_ub_3_0= RULE_DOUBLE_T
            {
            lv_ub_3_0=(Token)match(input,RULE_DOUBLE_T,FOLLOW_42); 

            					newLeafNode(lv_ub_3_0, grammarAccess.getIntervalSNAccess().getUbDOUBLE_TTerminalRuleCall_3_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getIntervalSNRule());
            					}
            					setWithLastConsumed(
            						current,
            						"ub",
            						lv_ub_3_0,
            						"org.eclipse.trace4cps.tl.Etl.DOUBLE_T");
            				

            }


            }

            otherlv_4=(Token)match(input,54,FOLLOW_2); 

            			newLeafNode(otherlv_4, grammarAccess.getIntervalSNAccess().getRightSquareBracketKeyword_4());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleIntervalSN"


    // $ANTLR start "entryRuleIntervalNS"
    // InternalEtl.g:2260:1: entryRuleIntervalNS returns [EObject current=null] : iv_ruleIntervalNS= ruleIntervalNS EOF ;
    public final EObject entryRuleIntervalNS() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleIntervalNS = null;


        try {
            // InternalEtl.g:2260:51: (iv_ruleIntervalNS= ruleIntervalNS EOF )
            // InternalEtl.g:2261:2: iv_ruleIntervalNS= ruleIntervalNS EOF
            {
             newCompositeNode(grammarAccess.getIntervalNSRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleIntervalNS=ruleIntervalNS();

            state._fsp--;

             current =iv_ruleIntervalNS; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleIntervalNS"


    // $ANTLR start "ruleIntervalNS"
    // InternalEtl.g:2267:1: ruleIntervalNS returns [EObject current=null] : (otherlv_0= '[' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) ) otherlv_5= ')' ) ;
    public final EObject ruleIntervalNS() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_lb_1_0=null;
        Token otherlv_2=null;
        Token lv_ub_3_0=null;
        Token lv_infty_4_0=null;
        Token otherlv_5=null;


        	enterRule();

        try {
            // InternalEtl.g:2273:2: ( (otherlv_0= '[' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) ) otherlv_5= ')' ) )
            // InternalEtl.g:2274:2: (otherlv_0= '[' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) ) otherlv_5= ')' )
            {
            // InternalEtl.g:2274:2: (otherlv_0= '[' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) ) otherlv_5= ')' )
            // InternalEtl.g:2275:3: otherlv_0= '[' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) ) otherlv_5= ')'
            {
            otherlv_0=(Token)match(input,55,FOLLOW_21); 

            			newLeafNode(otherlv_0, grammarAccess.getIntervalNSAccess().getLeftSquareBracketKeyword_0());
            		
            // InternalEtl.g:2279:3: ( (lv_lb_1_0= RULE_DOUBLE_T ) )
            // InternalEtl.g:2280:4: (lv_lb_1_0= RULE_DOUBLE_T )
            {
            // InternalEtl.g:2280:4: (lv_lb_1_0= RULE_DOUBLE_T )
            // InternalEtl.g:2281:5: lv_lb_1_0= RULE_DOUBLE_T
            {
            lv_lb_1_0=(Token)match(input,RULE_DOUBLE_T,FOLLOW_40); 

            					newLeafNode(lv_lb_1_0, grammarAccess.getIntervalNSAccess().getLbDOUBLE_TTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getIntervalNSRule());
            					}
            					setWithLastConsumed(
            						current,
            						"lb",
            						lv_lb_1_0,
            						"org.eclipse.trace4cps.tl.Etl.DOUBLE_T");
            				

            }


            }

            otherlv_2=(Token)match(input,50,FOLLOW_41); 

            			newLeafNode(otherlv_2, grammarAccess.getIntervalNSAccess().getCommaKeyword_2());
            		
            // InternalEtl.g:2301:3: ( ( (lv_ub_3_0= RULE_DOUBLE_T ) ) | ( (lv_infty_4_0= 'Infty' ) ) )
            int alt23=2;
            int LA23_0 = input.LA(1);

            if ( (LA23_0==RULE_DOUBLE_T) ) {
                alt23=1;
            }
            else if ( (LA23_0==53) ) {
                alt23=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 23, 0, input);

                throw nvae;
            }
            switch (alt23) {
                case 1 :
                    // InternalEtl.g:2302:4: ( (lv_ub_3_0= RULE_DOUBLE_T ) )
                    {
                    // InternalEtl.g:2302:4: ( (lv_ub_3_0= RULE_DOUBLE_T ) )
                    // InternalEtl.g:2303:5: (lv_ub_3_0= RULE_DOUBLE_T )
                    {
                    // InternalEtl.g:2303:5: (lv_ub_3_0= RULE_DOUBLE_T )
                    // InternalEtl.g:2304:6: lv_ub_3_0= RULE_DOUBLE_T
                    {
                    lv_ub_3_0=(Token)match(input,RULE_DOUBLE_T,FOLLOW_8); 

                    						newLeafNode(lv_ub_3_0, grammarAccess.getIntervalNSAccess().getUbDOUBLE_TTerminalRuleCall_3_0_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getIntervalNSRule());
                    						}
                    						setWithLastConsumed(
                    							current,
                    							"ub",
                    							lv_ub_3_0,
                    							"org.eclipse.trace4cps.tl.Etl.DOUBLE_T");
                    					

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:2321:4: ( (lv_infty_4_0= 'Infty' ) )
                    {
                    // InternalEtl.g:2321:4: ( (lv_infty_4_0= 'Infty' ) )
                    // InternalEtl.g:2322:5: (lv_infty_4_0= 'Infty' )
                    {
                    // InternalEtl.g:2322:5: (lv_infty_4_0= 'Infty' )
                    // InternalEtl.g:2323:6: lv_infty_4_0= 'Infty'
                    {
                    lv_infty_4_0=(Token)match(input,53,FOLLOW_8); 

                    						newLeafNode(lv_infty_4_0, grammarAccess.getIntervalNSAccess().getInftyInftyKeyword_3_1_0());
                    					

                    						if (current==null) {
                    							current = createModelElement(grammarAccess.getIntervalNSRule());
                    						}
                    						setWithLastConsumed(current, "infty", lv_infty_4_0, "Infty");
                    					

                    }


                    }


                    }
                    break;

            }

            otherlv_5=(Token)match(input,17,FOLLOW_2); 

            			newLeafNode(otherlv_5, grammarAccess.getIntervalNSAccess().getRightParenthesisKeyword_4());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleIntervalNS"


    // $ANTLR start "entryRuleIntervalNN"
    // InternalEtl.g:2344:1: entryRuleIntervalNN returns [EObject current=null] : iv_ruleIntervalNN= ruleIntervalNN EOF ;
    public final EObject entryRuleIntervalNN() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleIntervalNN = null;


        try {
            // InternalEtl.g:2344:51: (iv_ruleIntervalNN= ruleIntervalNN EOF )
            // InternalEtl.g:2345:2: iv_ruleIntervalNN= ruleIntervalNN EOF
            {
             newCompositeNode(grammarAccess.getIntervalNNRule()); 
            pushFollow(FOLLOW_1);
            iv_ruleIntervalNN=ruleIntervalNN();

            state._fsp--;

             current =iv_ruleIntervalNN; 
            match(input,EOF,FOLLOW_2); 

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleIntervalNN"


    // $ANTLR start "ruleIntervalNN"
    // InternalEtl.g:2351:1: ruleIntervalNN returns [EObject current=null] : (otherlv_0= '[' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( (lv_ub_3_0= RULE_DOUBLE_T ) ) otherlv_4= ']' ) ;
    public final EObject ruleIntervalNN() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_lb_1_0=null;
        Token otherlv_2=null;
        Token lv_ub_3_0=null;
        Token otherlv_4=null;


        	enterRule();

        try {
            // InternalEtl.g:2357:2: ( (otherlv_0= '[' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( (lv_ub_3_0= RULE_DOUBLE_T ) ) otherlv_4= ']' ) )
            // InternalEtl.g:2358:2: (otherlv_0= '[' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( (lv_ub_3_0= RULE_DOUBLE_T ) ) otherlv_4= ']' )
            {
            // InternalEtl.g:2358:2: (otherlv_0= '[' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( (lv_ub_3_0= RULE_DOUBLE_T ) ) otherlv_4= ']' )
            // InternalEtl.g:2359:3: otherlv_0= '[' ( (lv_lb_1_0= RULE_DOUBLE_T ) ) otherlv_2= ',' ( (lv_ub_3_0= RULE_DOUBLE_T ) ) otherlv_4= ']'
            {
            otherlv_0=(Token)match(input,55,FOLLOW_21); 

            			newLeafNode(otherlv_0, grammarAccess.getIntervalNNAccess().getLeftSquareBracketKeyword_0());
            		
            // InternalEtl.g:2363:3: ( (lv_lb_1_0= RULE_DOUBLE_T ) )
            // InternalEtl.g:2364:4: (lv_lb_1_0= RULE_DOUBLE_T )
            {
            // InternalEtl.g:2364:4: (lv_lb_1_0= RULE_DOUBLE_T )
            // InternalEtl.g:2365:5: lv_lb_1_0= RULE_DOUBLE_T
            {
            lv_lb_1_0=(Token)match(input,RULE_DOUBLE_T,FOLLOW_40); 

            					newLeafNode(lv_lb_1_0, grammarAccess.getIntervalNNAccess().getLbDOUBLE_TTerminalRuleCall_1_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getIntervalNNRule());
            					}
            					setWithLastConsumed(
            						current,
            						"lb",
            						lv_lb_1_0,
            						"org.eclipse.trace4cps.tl.Etl.DOUBLE_T");
            				

            }


            }

            otherlv_2=(Token)match(input,50,FOLLOW_21); 

            			newLeafNode(otherlv_2, grammarAccess.getIntervalNNAccess().getCommaKeyword_2());
            		
            // InternalEtl.g:2385:3: ( (lv_ub_3_0= RULE_DOUBLE_T ) )
            // InternalEtl.g:2386:4: (lv_ub_3_0= RULE_DOUBLE_T )
            {
            // InternalEtl.g:2386:4: (lv_ub_3_0= RULE_DOUBLE_T )
            // InternalEtl.g:2387:5: lv_ub_3_0= RULE_DOUBLE_T
            {
            lv_ub_3_0=(Token)match(input,RULE_DOUBLE_T,FOLLOW_42); 

            					newLeafNode(lv_ub_3_0, grammarAccess.getIntervalNNAccess().getUbDOUBLE_TTerminalRuleCall_3_0());
            				

            					if (current==null) {
            						current = createModelElement(grammarAccess.getIntervalNNRule());
            					}
            					setWithLastConsumed(
            						current,
            						"ub",
            						lv_ub_3_0,
            						"org.eclipse.trace4cps.tl.Etl.DOUBLE_T");
            				

            }


            }

            otherlv_4=(Token)match(input,54,FOLLOW_2); 

            			newLeafNode(otherlv_4, grammarAccess.getIntervalNNAccess().getRightSquareBracketKeyword_4());
            		

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleIntervalNN"


    // $ANTLR start "ruleTimeUnitEnum"
    // InternalEtl.g:2411:1: ruleTimeUnitEnum returns [Enumerator current=null] : ( (enumLiteral_0= 's' ) | (enumLiteral_1= 'ns' ) | (enumLiteral_2= 'us' ) | (enumLiteral_3= 'ms' ) | (enumLiteral_4= 'min' ) | (enumLiteral_5= 'hr' ) ) ;
    public final Enumerator ruleTimeUnitEnum() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;
        Token enumLiteral_2=null;
        Token enumLiteral_3=null;
        Token enumLiteral_4=null;
        Token enumLiteral_5=null;


        	enterRule();

        try {
            // InternalEtl.g:2417:2: ( ( (enumLiteral_0= 's' ) | (enumLiteral_1= 'ns' ) | (enumLiteral_2= 'us' ) | (enumLiteral_3= 'ms' ) | (enumLiteral_4= 'min' ) | (enumLiteral_5= 'hr' ) ) )
            // InternalEtl.g:2418:2: ( (enumLiteral_0= 's' ) | (enumLiteral_1= 'ns' ) | (enumLiteral_2= 'us' ) | (enumLiteral_3= 'ms' ) | (enumLiteral_4= 'min' ) | (enumLiteral_5= 'hr' ) )
            {
            // InternalEtl.g:2418:2: ( (enumLiteral_0= 's' ) | (enumLiteral_1= 'ns' ) | (enumLiteral_2= 'us' ) | (enumLiteral_3= 'ms' ) | (enumLiteral_4= 'min' ) | (enumLiteral_5= 'hr' ) )
            int alt24=6;
            switch ( input.LA(1) ) {
            case 56:
                {
                alt24=1;
                }
                break;
            case 57:
                {
                alt24=2;
                }
                break;
            case 58:
                {
                alt24=3;
                }
                break;
            case 59:
                {
                alt24=4;
                }
                break;
            case 60:
                {
                alt24=5;
                }
                break;
            case 61:
                {
                alt24=6;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 24, 0, input);

                throw nvae;
            }

            switch (alt24) {
                case 1 :
                    // InternalEtl.g:2419:3: (enumLiteral_0= 's' )
                    {
                    // InternalEtl.g:2419:3: (enumLiteral_0= 's' )
                    // InternalEtl.g:2420:4: enumLiteral_0= 's'
                    {
                    enumLiteral_0=(Token)match(input,56,FOLLOW_2); 

                    				current = grammarAccess.getTimeUnitEnumAccess().getSEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_0, grammarAccess.getTimeUnitEnumAccess().getSEnumLiteralDeclaration_0());
                    			

                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:2427:3: (enumLiteral_1= 'ns' )
                    {
                    // InternalEtl.g:2427:3: (enumLiteral_1= 'ns' )
                    // InternalEtl.g:2428:4: enumLiteral_1= 'ns'
                    {
                    enumLiteral_1=(Token)match(input,57,FOLLOW_2); 

                    				current = grammarAccess.getTimeUnitEnumAccess().getNSEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_1, grammarAccess.getTimeUnitEnumAccess().getNSEnumLiteralDeclaration_1());
                    			

                    }


                    }
                    break;
                case 3 :
                    // InternalEtl.g:2435:3: (enumLiteral_2= 'us' )
                    {
                    // InternalEtl.g:2435:3: (enumLiteral_2= 'us' )
                    // InternalEtl.g:2436:4: enumLiteral_2= 'us'
                    {
                    enumLiteral_2=(Token)match(input,58,FOLLOW_2); 

                    				current = grammarAccess.getTimeUnitEnumAccess().getUSEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_2, grammarAccess.getTimeUnitEnumAccess().getUSEnumLiteralDeclaration_2());
                    			

                    }


                    }
                    break;
                case 4 :
                    // InternalEtl.g:2443:3: (enumLiteral_3= 'ms' )
                    {
                    // InternalEtl.g:2443:3: (enumLiteral_3= 'ms' )
                    // InternalEtl.g:2444:4: enumLiteral_3= 'ms'
                    {
                    enumLiteral_3=(Token)match(input,59,FOLLOW_2); 

                    				current = grammarAccess.getTimeUnitEnumAccess().getMSEnumLiteralDeclaration_3().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_3, grammarAccess.getTimeUnitEnumAccess().getMSEnumLiteralDeclaration_3());
                    			

                    }


                    }
                    break;
                case 5 :
                    // InternalEtl.g:2451:3: (enumLiteral_4= 'min' )
                    {
                    // InternalEtl.g:2451:3: (enumLiteral_4= 'min' )
                    // InternalEtl.g:2452:4: enumLiteral_4= 'min'
                    {
                    enumLiteral_4=(Token)match(input,60,FOLLOW_2); 

                    				current = grammarAccess.getTimeUnitEnumAccess().getMINEnumLiteralDeclaration_4().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_4, grammarAccess.getTimeUnitEnumAccess().getMINEnumLiteralDeclaration_4());
                    			

                    }


                    }
                    break;
                case 6 :
                    // InternalEtl.g:2459:3: (enumLiteral_5= 'hr' )
                    {
                    // InternalEtl.g:2459:3: (enumLiteral_5= 'hr' )
                    // InternalEtl.g:2460:4: enumLiteral_5= 'hr'
                    {
                    enumLiteral_5=(Token)match(input,61,FOLLOW_2); 

                    				current = grammarAccess.getTimeUnitEnumAccess().getHREnumLiteralDeclaration_5().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_5, grammarAccess.getTimeUnitEnumAccess().getHREnumLiteralDeclaration_5());
                    			

                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTimeUnitEnum"


    // $ANTLR start "ruleAndOr"
    // InternalEtl.g:2470:1: ruleAndOr returns [Enumerator current=null] : ( (enumLiteral_0= 'and' ) | (enumLiteral_1= 'or' ) ) ;
    public final Enumerator ruleAndOr() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;


        	enterRule();

        try {
            // InternalEtl.g:2476:2: ( ( (enumLiteral_0= 'and' ) | (enumLiteral_1= 'or' ) ) )
            // InternalEtl.g:2477:2: ( (enumLiteral_0= 'and' ) | (enumLiteral_1= 'or' ) )
            {
            // InternalEtl.g:2477:2: ( (enumLiteral_0= 'and' ) | (enumLiteral_1= 'or' ) )
            int alt25=2;
            int LA25_0 = input.LA(1);

            if ( (LA25_0==43) ) {
                alt25=1;
            }
            else if ( (LA25_0==62) ) {
                alt25=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }
            switch (alt25) {
                case 1 :
                    // InternalEtl.g:2478:3: (enumLiteral_0= 'and' )
                    {
                    // InternalEtl.g:2478:3: (enumLiteral_0= 'and' )
                    // InternalEtl.g:2479:4: enumLiteral_0= 'and'
                    {
                    enumLiteral_0=(Token)match(input,43,FOLLOW_2); 

                    				current = grammarAccess.getAndOrAccess().getANDEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_0, grammarAccess.getAndOrAccess().getANDEnumLiteralDeclaration_0());
                    			

                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:2486:3: (enumLiteral_1= 'or' )
                    {
                    // InternalEtl.g:2486:3: (enumLiteral_1= 'or' )
                    // InternalEtl.g:2487:4: enumLiteral_1= 'or'
                    {
                    enumLiteral_1=(Token)match(input,62,FOLLOW_2); 

                    				current = grammarAccess.getAndOrAccess().getOREnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_1, grammarAccess.getAndOrAccess().getOREnumLiteralDeclaration_1());
                    			

                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleAndOr"


    // $ANTLR start "ruleCompOp"
    // InternalEtl.g:2497:1: ruleCompOp returns [Enumerator current=null] : ( (enumLiteral_0= '<=' ) | (enumLiteral_1= '==' ) | (enumLiteral_2= '>=' ) ) ;
    public final Enumerator ruleCompOp() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;
        Token enumLiteral_2=null;


        	enterRule();

        try {
            // InternalEtl.g:2503:2: ( ( (enumLiteral_0= '<=' ) | (enumLiteral_1= '==' ) | (enumLiteral_2= '>=' ) ) )
            // InternalEtl.g:2504:2: ( (enumLiteral_0= '<=' ) | (enumLiteral_1= '==' ) | (enumLiteral_2= '>=' ) )
            {
            // InternalEtl.g:2504:2: ( (enumLiteral_0= '<=' ) | (enumLiteral_1= '==' ) | (enumLiteral_2= '>=' ) )
            int alt26=3;
            switch ( input.LA(1) ) {
            case 63:
                {
                alt26=1;
                }
                break;
            case 64:
                {
                alt26=2;
                }
                break;
            case 65:
                {
                alt26=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 26, 0, input);

                throw nvae;
            }

            switch (alt26) {
                case 1 :
                    // InternalEtl.g:2505:3: (enumLiteral_0= '<=' )
                    {
                    // InternalEtl.g:2505:3: (enumLiteral_0= '<=' )
                    // InternalEtl.g:2506:4: enumLiteral_0= '<='
                    {
                    enumLiteral_0=(Token)match(input,63,FOLLOW_2); 

                    				current = grammarAccess.getCompOpAccess().getLEEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_0, grammarAccess.getCompOpAccess().getLEEnumLiteralDeclaration_0());
                    			

                    }


                    }
                    break;
                case 2 :
                    // InternalEtl.g:2513:3: (enumLiteral_1= '==' )
                    {
                    // InternalEtl.g:2513:3: (enumLiteral_1= '==' )
                    // InternalEtl.g:2514:4: enumLiteral_1= '=='
                    {
                    enumLiteral_1=(Token)match(input,64,FOLLOW_2); 

                    				current = grammarAccess.getCompOpAccess().getEQEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_1, grammarAccess.getCompOpAccess().getEQEnumLiteralDeclaration_1());
                    			

                    }


                    }
                    break;
                case 3 :
                    // InternalEtl.g:2521:3: (enumLiteral_2= '>=' )
                    {
                    // InternalEtl.g:2521:3: (enumLiteral_2= '>=' )
                    // InternalEtl.g:2522:4: enumLiteral_2= '>='
                    {
                    enumLiteral_2=(Token)match(input,65,FOLLOW_2); 

                    				current = grammarAccess.getCompOpAccess().getGEEnumLiteralDeclaration_2().getEnumLiteral().getInstance();
                    				newLeafNode(enumLiteral_2, grammarAccess.getCompOpAccess().getGEEnumLiteralDeclaration_2());
                    			

                    }


                    }
                    break;

            }


            }


            	leaveRule();

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleCompOp"

    // Delegated rules


    protected DFA16 dfa16 = new DFA16(this);
    protected DFA20 dfa20 = new DFA20(this);
    protected DFA21 dfa21 = new DFA21(this);
    static final String dfa_1s = "\16\uffff";
    static final String dfa_2s = "\1\uffff\1\15\14\uffff";
    static final String dfa_3s = "\1\4\1\15\14\uffff";
    static final String dfa_4s = "\1\61\1\101\14\uffff";
    static final String dfa_5s = "\2\uffff\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\1";
    static final String dfa_6s = "\16\uffff}>";
    static final String[] dfa_7s = {
            "\1\1\13\uffff\1\5\16\uffff\1\4\1\6\1\uffff\1\7\1\10\1\11\1\12\1\13\3\uffff\1\14\1\uffff\1\3\2\uffff\3\2",
            "\1\15\1\uffff\4\15\16\uffff\1\15\5\uffff\1\15\3\uffff\1\15\22\uffff\1\15\3\3",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_1 = DFA.unpackEncodedString(dfa_1s);
    static final short[] dfa_2 = DFA.unpackEncodedString(dfa_2s);
    static final char[] dfa_3 = DFA.unpackEncodedStringToUnsignedChars(dfa_3s);
    static final char[] dfa_4 = DFA.unpackEncodedStringToUnsignedChars(dfa_4s);
    static final short[] dfa_5 = DFA.unpackEncodedString(dfa_5s);
    static final short[] dfa_6 = DFA.unpackEncodedString(dfa_6s);
    static final short[][] dfa_7 = unpackEncodedStringArray(dfa_7s);

    class DFA16 extends DFA {

        public DFA16(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 16;
            this.eot = dfa_1;
            this.eof = dfa_2;
            this.min = dfa_3;
            this.max = dfa_4;
            this.accept = dfa_5;
            this.special = dfa_6;
            this.transition = dfa_7;
        }
        public String getDescription() {
            return "860:2: ( ( () ( (otherlv_1= RULE_ID ) ) (otherlv_2= '(' ( (lv_param_3_0= RULE_ID ) ) (otherlv_4= '+' ( (lv_val_5_0= RULE_INT_T ) ) )? otherlv_6= ')' )? ) | ( () ( (lv_mtlAP_8_0= ruleMtlAp ) ) ) | ( () ( (lv_stlAP_10_0= ruleStlAp ) ) ) | ( () otherlv_12= 'not' ( (lv_formula_13_0= ruleFormula ) ) ) | ( () otherlv_15= '(' ( (lv_left_16_0= ruleFormula ) ) ( (lv_op_17_0= ruleAndOr ) ) ( (lv_right_18_0= ruleFormula ) ) otherlv_19= ')' ) | ( () otherlv_21= 'if' ( (lv_left_22_0= ruleFormula ) ) otherlv_23= 'then' ( (lv_right_24_0= ruleFormula ) ) ) | ( () otherlv_26= 'globally' ( (lv_formula_27_0= ruleFormula ) ) ) | ( () otherlv_29= 'during' ( (lv_interval_30_0= ruleInterval ) ) ( (lv_formula_31_0= ruleFormula ) ) ) | ( () otherlv_33= 'finally' ( (lv_formula_34_0= ruleFormula ) ) ) | ( () otherlv_36= 'within' ( (lv_interval_37_0= ruleInterval ) ) ( (lv_formula_38_0= ruleFormula ) ) ) | ( () otherlv_40= 'until' ( (lv_right_41_0= ruleFormula ) ) otherlv_42= 'we' otherlv_43= 'have' otherlv_44= 'that' ( (lv_left_45_0= ruleFormula ) ) ) | ( () otherlv_47= 'by' ( (lv_interval_48_0= ruleInterval ) ) ( (lv_right_49_0= ruleFormula ) ) otherlv_50= 'and' otherlv_51= 'until' otherlv_52= 'then' ( (lv_left_53_0= ruleFormula ) ) ) )";
        }
    }
    static final String dfa_8s = "\12\uffff";
    static final String dfa_9s = "\1\uffff\1\4\1\6\4\uffff\1\11\2\uffff";
    static final String dfa_10s = "\1\4\2\36\1\4\3\uffff\1\36\2\uffff";
    static final String dfa_11s = "\1\7\2\64\1\4\3\uffff\1\64\2\uffff";
    static final String dfa_12s = "\4\uffff\1\1\1\4\1\2\1\uffff\1\5\1\3";
    static final String dfa_13s = "\12\uffff}>";
    static final String[] dfa_14s = {
            "\1\2\2\uffff\1\1",
            "\1\3\23\uffff\3\4",
            "\1\5\23\uffff\3\6",
            "\1\7",
            "",
            "",
            "",
            "\1\10\23\uffff\3\11",
            "",
            ""
    };

    static final short[] dfa_8 = DFA.unpackEncodedString(dfa_8s);
    static final short[] dfa_9 = DFA.unpackEncodedString(dfa_9s);
    static final char[] dfa_10 = DFA.unpackEncodedStringToUnsignedChars(dfa_10s);
    static final char[] dfa_11 = DFA.unpackEncodedStringToUnsignedChars(dfa_11s);
    static final short[] dfa_12 = DFA.unpackEncodedString(dfa_12s);
    static final short[] dfa_13 = DFA.unpackEncodedString(dfa_13s);
    static final short[][] dfa_14 = unpackEncodedStringArray(dfa_14s);

    class DFA20 extends DFA {

        public DFA20(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 20;
            this.eot = dfa_8;
            this.eof = dfa_9;
            this.min = dfa_10;
            this.max = dfa_11;
            this.accept = dfa_12;
            this.special = dfa_13;
            this.transition = dfa_14;
        }
        public String getDescription() {
            return "1797:2: ( ( (lv_left_0_0= RULE_STRING ) ) | ( (lv_id_1_0= RULE_ID ) ) | ( ( (lv_left_2_0= RULE_STRING ) ) otherlv_3= '+' ( (lv_id_4_0= RULE_ID ) ) ) | ( ( (lv_id_5_0= RULE_ID ) ) otherlv_6= '+' ( (lv_right_7_0= RULE_STRING ) ) ) | ( ( (lv_left_8_0= RULE_STRING ) ) otherlv_9= '+' ( (lv_id_10_0= RULE_ID ) ) otherlv_11= '+' ( (lv_right_12_0= RULE_STRING ) ) ) )";
        }
    }
    static final String dfa_15s = "\15\uffff";
    static final String dfa_16s = "\1\20\2\6\2\62\2\6\1\21\1\uffff\1\21\3\uffff";
    static final String dfa_17s = "\1\67\2\6\2\62\2\65\1\66\1\uffff\1\66\3\uffff";
    static final String dfa_18s = "\10\uffff\1\1\1\uffff\1\3\1\2\1\4";
    static final String dfa_19s = "\15\uffff}>";
    static final String[] dfa_20s = {
            "\1\1\46\uffff\1\2",
            "\1\3",
            "\1\4",
            "\1\5",
            "\1\6",
            "\1\7\56\uffff\1\10",
            "\1\11\56\uffff\1\12",
            "\1\10\44\uffff\1\13",
            "",
            "\1\12\44\uffff\1\14",
            "",
            "",
            ""
    };

    static final short[] dfa_15 = DFA.unpackEncodedString(dfa_15s);
    static final char[] dfa_16 = DFA.unpackEncodedStringToUnsignedChars(dfa_16s);
    static final char[] dfa_17 = DFA.unpackEncodedStringToUnsignedChars(dfa_17s);
    static final short[] dfa_18 = DFA.unpackEncodedString(dfa_18s);
    static final short[] dfa_19 = DFA.unpackEncodedString(dfa_19s);
    static final short[][] dfa_20 = unpackEncodedStringArray(dfa_20s);

    class DFA21 extends DFA {

        public DFA21(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 21;
            this.eot = dfa_15;
            this.eof = dfa_15;
            this.min = dfa_16;
            this.max = dfa_17;
            this.accept = dfa_18;
            this.special = dfa_19;
            this.transition = dfa_20;
        }
        public String getDescription() {
            return "2005:3: ( ( (lv_iss_0_0= ruleIntervalSS ) ) | ( (lv_isn_1_0= ruleIntervalSN ) ) | ( (lv_ins_2_0= ruleIntervalNS ) ) | ( (lv_inn_3_0= ruleIntervalNN ) ) )";
        }
    }
 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x000000000004A002L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x000200001D200000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000014000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0003947D80010010L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0003947D80090010L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0003800000000010L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x0000000020800002L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x3F00000000000000L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000020000002L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000000022000002L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_22 = new BitSet(new long[]{0x0000000000010002L});
    public static final BitSet FOLLOW_23 = new BitSet(new long[]{0x0000000040020000L});
    public static final BitSet FOLLOW_24 = new BitSet(new long[]{0x4000080000000000L});
    public static final BitSet FOLLOW_25 = new BitSet(new long[]{0x0000000200000000L});
    public static final BitSet FOLLOW_26 = new BitSet(new long[]{0x0080000000010000L});
    public static final BitSet FOLLOW_27 = new BitSet(new long[]{0x0000008000000000L});
    public static final BitSet FOLLOW_28 = new BitSet(new long[]{0x0000010000000000L});
    public static final BitSet FOLLOW_29 = new BitSet(new long[]{0x0000020000000000L});
    public static final BitSet FOLLOW_30 = new BitSet(new long[]{0x0000080000000000L});
    public static final BitSet FOLLOW_31 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_32 = new BitSet(new long[]{0x8000000000000000L,0x0000000000000003L});
    public static final BitSet FOLLOW_33 = new BitSet(new long[]{0x0000200000000000L});
    public static final BitSet FOLLOW_34 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_35 = new BitSet(new long[]{0x0000000000000090L});
    public static final BitSet FOLLOW_36 = new BitSet(new long[]{0x000C000000000000L});
    public static final BitSet FOLLOW_37 = new BitSet(new long[]{0x0010000000000000L});
    public static final BitSet FOLLOW_38 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_39 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_40 = new BitSet(new long[]{0x0004000000000000L});
    public static final BitSet FOLLOW_41 = new BitSet(new long[]{0x0020000000000040L});
    public static final BitSet FOLLOW_42 = new BitSet(new long[]{0x0040000000000000L});

}